//----------------------------------------------------------------------------------------------
//
// Action - Kill Target Advanced
//
//----------------------------------------------------------------------------------------------
//
// Tries to kill the selected target, handles switching of arrows, aim setting etc.
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-17   Initial version.
//
//----------------------------------------------------------------------------------------------
//
// FIXME:
//  - Uses functions from regular KillTarget action, i actually want to inherit it, but
//    my inheritance implementation only handles one level right now.
//  - Upgrade to generic action
//
//----------------------------------------------------------------------------------------------

function Action_KillTargetAdvanced()
{
  // Member variables
  this.mCurrentTarget = null;
  this.mNofMisses = 0;

  this.mAmmoType = new Dictionary();
  
  // FIXME:
  //  - Should read from xml config file instead!
  //  - Support multiple types in case of arrows already equipped?
  
  this.mAmmoType.add( "Diamond Golem",          "Deadly Blunt Arrow" );
  this.mAmmoType.add( "Pyreal Golem",           "Deadly Blunt Arrow" );
  this.mAmmoType.add( "Obsidian Golem",         "Deadly Blunt Arrow" );
  this.mAmmoType.add( "Unstable Magma Golem",   "Deadly Frost Arrow" );
  this.mAmmoType.add( "Magma Golem",            "Deadly Frost Arrow" );
  this.mAmmoType.add( "Vapor Golem",            "Deadly Frost Arrow" );
  this.mAmmoType.add( "Plasma Golem",           "Deadly Frost Arrow" );
  this.mAmmoType.add( "Behemoth of Tenkarrdun", "Deadly Frost Arrow" );

  this.mAmmoType.add( "Fire Wisp",              "Deadly Armor Piercing Arrow" );
  this.mAmmoType.add( "Shadow Wisp",            "Deadly Armor Piercing Arrow" );
  this.mAmmoType.add( "Nightmare Wisp",         "Deadly Armor Piercing Arrow" );

  this.mAmmoType.add( "Firestorm",              "Deadly Frost Arrow" );
  this.mAmmoType.add( "Hellfire",               "Deadly Frost Arrow" );
  this.mAmmoType.add( "Inferno",                "Deadly Frost Arrow" );

  this.mAmmoType.add( "Sewer Rat",              "Deadly Armor Piercing Arrow" );

  this.mAmmoType.add( "Dark Revenant",          "Deadly Blunt Arrow" );
  this.mAmmoType.add( "Skeleton Bone Lord",     "Deadly Blunt Arrow" );
  this.mAmmoType.add( "Relic Bones",            "Deadly Blunt Arrow" );
  this.mAmmoType.add( "Cursed Bones",           "Deadly Blunt Arrow" );
  
  this.mAmmoType.add( "Injured Olthoi",         "Deadly Blunt Arrow" );
  this.mAmmoType.add( "Olthoi Nymph",           "Deadly Blunt Arrow" );
  this.mAmmoType.add( "Olthoi Worker",          "Deadly Blunt Arrow" );
  this.mAmmoType.add( "Olthoi Soldier",         "Deadly Blunt Arrow" );
  this.mAmmoType.add( "Olthoi Noble",           "Deadly Blunt Arrow" );
  
  this.mAmmoType.add( "Panumbris Shadow",       "Deadly Frog Crotch Arrow" );
  this.mAmmoType.add( "Umbris Shadow",          "Deadly Frog Crotch Arrow" );

  this.mAmmoType.add( "Lady Aerfalle",          "Deadly Frog Crotch Arrow" );


  // Member functions
  this.StartAction = Action_KillTarget_StartAction;
  this.PauseAction = Action_KillTarget_PauseAction;
  this.ResumeAction = Action_KillTarget_ResumeAction;
  this.Attack = Action_KillTargetAdvanced_Attack;
  this.KillTarget_Attack = Action_KillTarget_Attack;
  this.WaitUntilDead = Action_KillTarget_WaitUntilDead;
  this.OnMeleeDamageOther = Action_KillTarget_OnMeleeDamageOther;
  this.OnChatServer = Action_KillTarget_OnChatServer;
  this.SetWeaponName = Action_KillTarget_SetWeaponName;
  this.SetWieldAction = Action_KillTarget_SetWieldAction;
  this.SetTarget = Action_KillTarget_SetTarget;
}

//----------------------------------------------------------------------------------------------

function Action_KillTargetAdvanced_Attack()
{
  if( !this.mCurrentTarget.fExists )
  {
    gLog.DebugLine( "Lib.Action.KillTarget.Attack", "Target no longer valid" );
    return;
  }
  
  // Make sure correct ammo type
  if( skapi.AcoFromEqm( eqmAmmo ) == null || skapi.AcoFromEqm( eqmAmmo ).szName != this.mAmmoType.Item( this.mCurrentTarget.szName ) )
  {
    gLog.DebugLine( "Lib.Action.KillTarget.Attack", "Target: "+this.mCurrentTarget.szName );
    gLog.DebugLine( "Lib.Action.KillTarget.Attack", "Current Ammo: "+AcoToString( skapi.AcoFromEqm( eqmAmmo ) ) );
    gLog.DebugLine( "Lib.Action.KillTarget.Attack", "Wanted Ammo: "+this.mAmmoType.Item( this.mCurrentTarget.szName ) );
    this.mActionManager.GetAction( "EquipArrows" ).SetItemName( this.mAmmoType.Item( this.mCurrentTarget.szName ) );
    this.mActionManager.AddAction( "EquipArrows" );
    if( this.mIsPaused )
    {
      return;
    }
  }

  this.KillTarget_Attack();
}

//----------------------------------------------------------------------------------------------
