//----------------------------------------------------------------------------------------------
//
// State - Idle Sucess
//
//----------------------------------------------------------------------------------------------
//
// Sets state transition to success when action manager has been idle for set amount of time
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-27   Initial version.
//
//----------------------------------------------------------------------------------------------
//
// FIXME:
//  - Upgrade to generic state handler
//
//----------------------------------------------------------------------------------------------

function State_IdleSuccess()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_IdleSuccess_EnterState;
  this.ExitState = State_IdleSuccess_ExitState;
  this.OnActionFailed = State_IdleSuccess_OnActionFailed;
  this.SetIdleTime = State_IdleSuccess_SetIdleTime;
  this.OnTimer = State_IdleSuccess_OnTimer;

}

//----------------------------------------------------------------------------------------------

function State_IdleSuccess_EnterState()
{
  gLog.TraceLine( "State.IdleSuccess.EnterState", ">> State.IdleSuccess.EnterState" );

  this.Inherited_EnterState();
  if( this.mIdleTime > 1000 )
  {
    gTimer.AddTimeout( "IdleTimer", 1000, this, true );
  }
  else
  {
    gTimer.AddTimeout( "IdleTimer", 100, this, true );
  }

  gLog.TraceLine( "Lib.State.IdleSuccess.EnterState", "<< State.IdleSuccess.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_IdleSuccess_ExitState()
{
  gLog.TraceLine( "State.IdleSuccess.ExitState", ">> State.IdleSuccess.ExitState" );

  gTimer.RemoveTimeout( "IdleTimer" );
  this.Inherited_ExitState();

  gLog.TraceLine( "State.IdleSuccess.ExitState", "<< State.IdleSuccess.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_IdleSuccess_OnTimer( pData )
{
  if( this.mActionManager.IdleTime() > this.mIdleTime )
  {
    this.mStateMachine.ChangeState( "Success" );
  }
}

//----------------------------------------------------------------------------------------------

function State_IdleSuccess_SetIdleTime( pIdleTime )
{
  this.mIdleTime = pIdleTime;
}

//----------------------------------------------------------------------------------------------

function State_IdleSuccess_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
