//----------------------------------------------------------------------------------------------
//
// State - Navigate Ignore Monsters
//
//----------------------------------------------------------------------------------------------
//
// Running around outside without killing stuff
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-03-15   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_NavigateIgnoreMonsters()
{
  // Member variables
  this.mSubStates = new Array();
  this.mRouteAction = "";

  // Member functions
  this.EnterState = State_NavigateIgnoreMonsters_EnterState;
  this.ExitState = State_NavigateIgnoreMonsters_ExitState;
  this.Execute = State_NavigateIgnoreMonsters_Execute;
  this.SetRouteAction = State_NavigateIgnoreMonsters_SetRouteAction;
  this.OnActionFailed = State_NavigateIgnoreMonsters_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_NavigateIgnoreMonsters_EnterState()
{
  gLog.TraceLine( "State.NavigateIgnoreMonsters.EnterState", ">> State.NavigateIgnoreMonsters.EnterState" );

  this.Inherited_EnterState();
  this.mActionManager.AddAction( this.mRouteAction );

  gLog.TraceLine( "Lib.State.NavigateIgnoreMonsters.EnterState", "<< State.NavigateIgnoreMonsters.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_NavigateIgnoreMonsters_ExitState()
{
  gLog.TraceLine( "State.NavigateIgnoreMonsters.ExitState", ">> State.NavigateIgnoreMonsters.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.NavigateIgnoreMonsters.ExitState", "<< State.NavigateIgnoreMonsters.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_NavigateIgnoreMonsters_Execute()
{
  gLog.TraceLine( "State.NavigateIgnoreMonsters.Execute", ">> State.NavigateIgnoreMonsters.Execute" );

  while( !this.mStateMachine.ShouldExitState() )
  {

    this.mActionManager.ExecuteAction();
    skapi.WaitEvent( 0 );

    if( !this.mActionManager.HasActiveAction( this.mRouteAction ) )
    {
      this.mStateMachine.ChangeState( "Success" );    
    }

  }

  gLog.TraceLine( "State.NavigateIgnoreMonsters.Execute", "<< State.NavigateIgnoreMonsters.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_NavigateIgnoreMonsters_SetRouteAction( pRouteAction )
{
  this.mRouteAction = pRouteAction
}

//----------------------------------------------------------------------------------------------

function State_NavigateIgnoreMonsters_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
