//----------------------------------------------------------------------------------------------
//
// State - Idle Sucess
//
//----------------------------------------------------------------------------------------------
//
// Sets state transition to success when action manager has been idle for set amount of time
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-27   Initial version.
//
//----------------------------------------------------------------------------------------------
//
// FIXME:
//  - Upgrade to generic state handler
//
//----------------------------------------------------------------------------------------------

function State_WaitSpawn()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_WaitSpawn_EnterState;
  this.ExitState = State_WaitSpawn_ExitState;
  this.OnActionFailed = State_WaitSpawn_OnActionFailed;
  this.SetName = State_WaitSpawn_SetName;
  this.OnTimer = State_WaitSpawn_OnTimer;

}

//----------------------------------------------------------------------------------------------

function State_WaitSpawn_EnterState()
{
  gLog.TraceLine( "State.WaitSpawn.EnterState", ">> State.WaitSpawn.EnterState" );

  this.Inherited_EnterState();
  gTimer.AddTimeout( "SpawnTimer", 1000, this, true );

  gLog.TraceLine( "Lib.State.WaitSpawn.EnterState", "<< State.WaitSpawn.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_WaitSpawn_ExitState()
{
  gLog.TraceLine( "State.WaitSpawn.ExitState", ">> State.WaitSpawn.ExitState" );

  gTimer.RemoveTimeout( "SpawnTimer" );
  this.Inherited_ExitState();

  gLog.TraceLine( "State.WaitSpawn.ExitState", "<< State.WaitSpawn.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_WaitSpawn_OnTimer( pData )
{
  var vAcf = skapi.AcfNew();
  vAcf.szName = this.mName;
  var vItem = vAcf.AcoGet();
  
  if( vItem != null )
  {
    this.mStateMachine.ChangeState( "Success" );
  }
}

//----------------------------------------------------------------------------------------------

function State_WaitSpawn_SetName( pName )
{
  this.mName = pName;
}

//----------------------------------------------------------------------------------------------

function State_WaitSpawn_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
