//----------------------------------------------------------------------------------------------
//
// State - Get Sluice
//
//----------------------------------------------------------------------------------------------
//
// runs to sluice, picks it up and recalls
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-27   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_GetSluice()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_GetSluice_EnterState;
  this.ExitState = State_GetSluice_ExitState;
  this.Execute = State_GetSluice_Execute;
  this.OnActionFailed = State_GetSluice_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_GetSluice_EnterState()
{
  gLog.TraceLine( "State.GetSluice.EnterState", ">> State.GetSluice.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.GetSluice.EnterState", "<< State.GetSluice.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_GetSluice_ExitState()
{
  gLog.TraceLine( "State.GetSluice.ExitState", ">> State.GetSluice.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.GetSluice.ExitState", "<< State.GetSluice.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_GetSluice_Execute()
{
  gLog.TraceLine( "State.GetSluice.Execute", ">> State.GetSluice.Execute" );

  this.DoActionSequence( new Array( "UseHealKit", "EquipBow", "Navigate_LedgeToSluice" ) );

  var vAcf = skapi.AcfNew();
  vAcf.szName = "Sluice Gate Bar"
  vAcf.olc = olcOnGround;
  var vSluice = vAcf.AcoGet();
  if( vSluice != null )
  {
    vSluice.Use();
    skapi.WaitEvent( 5000, wemFullTimeout );
  }

  this.DoActionSequence( new Array( "EquipWand", "CombatMode" ) );

  skapi.CastSpell( skapi.SpellidFromSz( "Aerlinthe Recall" ) );
  skapi.WaitEvent( 60000, wemSpecific, evidOnEndPortalSelf );

  this.mStateMachine.ChangeState( "Success" );

  gLog.TraceLine( "State.GetSluice.Execute", "<< State.GetSluice.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_GetSluice_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
