//----------------------------------------------------------------------------------------------
//
// State - Unlock Door
//
//----------------------------------------------------------------------------------------------
//
// 
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-04-10   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_UnlockDoor()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_UnlockDoor_EnterState;
  this.ExitState = State_UnlockDoor_ExitState;
  this.Execute = State_UnlockDoor_Execute;
  this.OnActionFailed = State_UnlockDoor_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_UnlockDoor_EnterState()
{
  gLog.TraceLine( "State.UnlockDoor.EnterState", ">> State.UnlockDoor.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.UnlockDoor.EnterState", "<< State.UnlockDoor.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_UnlockDoor_ExitState()
{
  gLog.TraceLine( "State.UnlockDoor.ExitState", ">> State.UnlockDoor.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.UnlockDoor.ExitState", "<< State.UnlockDoor.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_UnlockDoor_Execute()
{
  gLog.TraceLine( "State.UnlockDoor.Execute", ">> State.UnlockDoor.Execute" );

  // Nav to door
  this.DoAction( "Navigate_LedgeToDoor2" );
  
  // cast spell weaken lock on door
  var vAcf = skapi.AcfNew();
  vAcf.szName = "Door";
  vAcf.distMax = 0.1;
  var vDoor = vAcf.AcoGetSorted( skapi.sortbyDist );

  this.DoActionSequence( new Array( "EquipWand", "CombatMode" ) );
  skapi.WaitEvent( 1000, wemFullTimeout );
  
  skapi.CastSpell( skapi.SpellidFromSz( "Vagabond's Gift" ), vDoor );
  skapi.WaitEvent( 5000, wemFullTimeout );
  

  // unlock door
  vAcf = skapi.AcfNew();
  vAcf.szName = "Peerless Lockpick";
  vAcf.olc = olcInventory;

  var vLockpick = vAcf.AcoGet();
  vLockpick.UseOnAco( vDoor );  

  skapi.WaitEvent( 1000, wemFullTimeout );

  
  // open door
  vDoor.Use();
  skapi.WaitEvent( 1000, wemFullTimeout );

  
  // run to jump
  this.DoAction( "Navigate_Door2ToJump" );
  
  // kill diamonds
  while( true )
  {
    this.DoAction( "UseHealKit" );

    vAcf = skapi.AcfNew();
  
    vAcf.szName = "Diamond Golem";
    vAcf.distMax = 0.1;
    
    vTarget = vAcf.AcoGetSorted( skapi.sortbyDist );
    
    if( vTarget == null )
    {
      break;
    }
    
    this.mActionManager.GetAction( "KillTarget" ).SetTarget( vTarget );
    this.DoAction( "KillTarget" );
  }
//  this.DoAction( "Pause" );
  
  // run to jump pillar
  this.DoAction( "Navigate_JumpToPillarJump" );
  
  // jump
  skapi.TurnToHead( 0 );
  skapi.WaitEvent( 5000, wemSpecific, evidOnNavStop );

  gInteract.KeyDown( cmidWalkForward );
  gInteract.KeyDown( cmidHoldRun );
  gInteract.KeyDown( cmidJump );
  skapi.WaitEvent( 500, wemFullTimeout );
  gInteract.KeyUp( cmidJump );
  gInteract.KeyUp( cmidWalkForward );
  gInteract.KeyUp( cmidHoldRun );

  skapi.WaitEvent( 3000, wemFullTimeout );
  
  // pull lever
  vAcf = skapi.AcfNew();
  
  vAcf.szName = "Lever";
  vAcf.distMax = 0.1;
  
  var vLever = vAcf.AcoGetSorted( skapi.sortbyDist );
  vLever.Use();
  
  skapi.WaitEvent( 2000, wemFullTimeout );

  // jump off
  skapi.TurnTohead( 250 );
  skapi.WaitEvent( 5000, wemSpecific, evidOnNavStop );
  
  gInteract.KeyDown( cmidHoldRun );
  gInteract.KeyDown( cmidJump );
  gInteract.KeyDown( cmidWalkForward );
  skapi.WaitEvent( 500, wemFullTimeout );
  gInteract.KeyUp( cmidJump );
  gInteract.KeyUp( cmidWalkForward );
  gInteract.KeyUp( cmidHoldRun );
  
  skapi.WaitEvent( 1000, wemFullTimeout );

  // run to ledge
  this.DoActionSequence( new Array( "Navigate_LedgeToDoor2", "Navigate_Door2ToJump" ) );

  // jump across
  skapi.WaitEvent( 4000, wemFullTimeout );
  
  skapi.TurnToHead( 180 );
  skapi.WaitEvent( 5000, wemSpecific, evidOnNavStop );

  gInteract.KeyDown( cmidJump );
  gInteract.KeyDown( cmidWalkForward );
  skapi.WaitEvent( 1000, wemFullTimeout );
  gInteract.KeyUp( cmidJump );
  gInteract.KeyUp( cmidWalkForward );
  
  // move past door
  
  this.mStateMachine.ChangeState( "Success" );

  gLog.TraceLine( "State.UnlockDoor.Execute", "<< State.UnlockDoor.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_UnlockDoor_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
