//----------------------------------------------------------------------------------------------
//
// State - jump first trap 
//
//----------------------------------------------------------------------------------------------
//
// jumps past first trap in keep
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-27   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_JumpTrap1()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_JumpTrap1_EnterState;
  this.ExitState = State_JumpTrap1_ExitState;
  this.Execute = State_JumpTrap1_Execute;
  this.OnActionFailed = State_JumpTrap1_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_JumpTrap1_EnterState()
{
  gLog.TraceLine( "State.JumpTrap1.EnterState", ">> State.JumpTrap1.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.JumpTrap1.EnterState", "<< State.JumpTrap1.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_JumpTrap1_ExitState()
{
  gLog.TraceLine( "State.JumpTrap1.ExitState", ">> State.JumpTrap1.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.JumpTrap1.ExitState", "<< State.JumpTrap1.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_JumpTrap1_Execute()
{
  gLog.TraceLine( "State.JumpTrap1.Execute", ">> State.JumpTrap1.Execute" );

  // jump
  skapi.TurnToHead( 0 );
  skapi.WaitEvent( 5000, wemSpecific, evidOnNavStop );

  gInteract.KeyDown( cmidJump );
  gInteract.KeyDown( cmidWalkForward );
  skapi.WaitEvent( 200, wemFullTimeout );
  gInteract.KeyUp( cmidJump );
  gInteract.KeyUp( cmidWalkForward );

  this.mStateMachine.ChangeState( "Success" );

  gLog.TraceLine( "State.JumpTrap1.Execute", "<< State.JumpTrap1.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_JumpTrap1_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
