//----------------------------------------------------------------------------------------------
//
// State - Pulls levers
//
//----------------------------------------------------------------------------------------------
//
// Pulls all nearby levers
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-27   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_PullLevers()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_PullLevers_EnterState;
  this.ExitState = State_PullLevers_ExitState;
  this.Execute = State_PullLevers_Execute;
  this.OnActionFailed = State_PullLevers_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_PullLevers_EnterState()
{
  gLog.TraceLine( "State.PullLevers.EnterState", ">> State.PullLevers.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.PullLevers.EnterState", "<< State.PullLevers.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_PullLevers_ExitState()
{
  gLog.TraceLine( "State.PullLevers.ExitState", ">> State.PullLevers.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.PullLevers.ExitState", "<< State.PullLevers.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_PullLevers_Execute()
{
  gLog.TraceLine( "State.PullLevers.Execute", ">> State.PullLevers.Execute" );

  var vAcf = skapi.AcfNew();
  
  vAcf.szName = "Lever";
  vAcf.distMax = 0.02;

  var vLevers = vAcf.CoacoGet();  

  var e = new Enumerator( vLevers );

  for( ; !e.atEnd(); e.moveNext() )
  {
    var vLever = e.item();
    
    vLever.Use();
    skapi.WaitEvent( 4000, wemFullTimeout );
  }

  this.mStateMachine.ChangeState( "Success" );

  gLog.TraceLine( "State.PullLevers.Execute", "<< State.PullLevers.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_PullLevers_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
