//----------------------------------------------------------------------------------------------
//
// State - Step 03
//
//----------------------------------------------------------------------------------------------
//
// Runs from drop point to foundry
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-03-16   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_Step03()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_Step03_EnterState;
  this.ExitState = State_Step03_ExitState;
  this.Execute = State_Step03_Execute;
  this.OnActionFailed = State_Step03_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_Step03_EnterState()
{
  gLog.TraceLine( "State.Step03.EnterState", ">> State.Step03.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.Step03.EnterState", "<< State.Step03.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_Step03_ExitState()
{
  gLog.TraceLine( "State.Step03.ExitState", ">> State.Step03.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.Step03.ExitState", "<< State.Step03.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_Step03_Execute()
{
  gLog.TraceLine( "State.Step03.Execute", ">> State.Step03.Execute" );

  // -------------------------------------------------------------------------------------------

  var vStateModel;
  var vStateMachine;
  var vActionManager;

  // -------------------------------------------------------------------------------------------
  
  skapi.outputLine( "Initializing Step III..." );
  
  vStateModel = new StateModel();
  vStateModel.ReadConfigFromFile( "NavigateOutside/Config/StateModel_03.xml" );

  vActionManager = new ActionManager();
  vActionManager.ReadConfigFromFile( "NavigateOutside/Config/Action_03.xml" );
  
  vStateMachine = new StateMachine();
  vStateMachine.SetStateModel( vStateModel );
  vStateMachine.SetActionManager( vActionManager );  

  skapi.outputLine( "Initialization complete!" );

  // -------------------------------------------------------------------------------------------

  vStateMachine.Execute( "Rebuff1" );
//  vStateMachine.Execute( "NavigateDropToFoundry" );
  
  skapi.WaitEvent( 60000, wemSpecific, evidOnEndPortalSelf );
  
  // -------------------------------------------------------------------------------------------

  this.mStateMachine.ChangeState( "Success" );

  // -------------------------------------------------------------------------------------------

  gLog.TraceLine( "State.Step03.Execute", "<< State.Step03.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_Step03_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
