//----------------------------------------------------------------------------------------------
//
// State - Step 04
//
//----------------------------------------------------------------------------------------------
//
// Runs inside foundry, gets sluice and recalls to drop point
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-03-16   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_Step04()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_Step04_EnterState;
  this.ExitState = State_Step04_ExitState;
  this.Execute = State_Step04_Execute;
  this.OnActionFailed = State_Step04_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_Step04_EnterState()
{
  gLog.TraceLine( "State.Step04.EnterState", ">> State.Step04.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.Step04.EnterState", "<< State.Step04.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_Step04_ExitState()
{
  gLog.TraceLine( "State.Step04.ExitState", ">> State.Step04.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.Step04.ExitState", "<< State.Step04.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_Step04_Execute()
{
  gLog.TraceLine( "State.Step04.Execute", ">> State.Step04.Execute" );

  // -------------------------------------------------------------------------------------------

  var vStateModel;
  var vStateMachine;
  var vActionManager;

  // -------------------------------------------------------------------------------------------

  skapi.outputLine( "Initializing Step IV..." );
  
  vStateModel = new StateModel();
  vStateModel.ReadConfigFromFile( "Foundry/Config/StateModel_04.xml" );

  vActionManager = new ActionManager();
  vActionManager.ReadConfigFromFile( "Foundry/Config/Action_04.xml" );
  
  vStateMachine = new StateMachine();
  vStateMachine.SetStateModel( vStateModel );
  vStateMachine.SetActionManager( vActionManager );  

  skapi.outputLine( "Initialization complete!" );

  // -------------------------------------------------------------------------------------------

  vStateMachine.Execute( "NavigateDropToStairs" );
//  vStateMachine.Execute( "KillSluiceRoom" );

  // -------------------------------------------------------------------------------------------

  this.mStateMachine.ChangeState( "Success" );

  // -------------------------------------------------------------------------------------------

  gLog.TraceLine( "State.Step04.Execute", "<< State.Step04.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_Step04_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
