//----------------------------------------------------------------------------------------------
//
// State - Step 05
//
//----------------------------------------------------------------------------------------------
//
// Runs from drop point to safe platform before reservoir, and buffs for reservoir
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-03-16   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_Step05()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_Step05_EnterState;
  this.ExitState = State_Step05_ExitState;
  this.Execute = State_Step05_Execute;
  this.OnActionFailed = State_Step05_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_Step05_EnterState()
{
  gLog.TraceLine( "State.Step05.EnterState", ">> State.Step05.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.Step05.EnterState", "<< State.Step05.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_Step05_ExitState()
{
  gLog.TraceLine( "State.Step05.ExitState", ">> State.Step05.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.Step05.ExitState", "<< State.Step05.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_Step05_Execute()
{
  gLog.TraceLine( "State.Step05.Execute", ">> State.Step05.Execute" );

  // -------------------------------------------------------------------------------------------

  var vStateModel;
  var vStateMachine;
  var vActionManager;

  // -------------------------------------------------------------------------------------------
  
  skapi.outputLine( "Initializing Step V..." );
  
  vStateModel = new StateModel();
  vStateModel.ReadConfigFromFile( "NavigateOutside/Config/StateModel_05.xml" );

  vActionManager = new ActionManager();
  vActionManager.ReadConfigFromFile( "NavigateOutside/Config/Action_05.xml" );
  
  vStateMachine = new StateMachine();
  vStateMachine.SetStateModel( vStateModel );
  vStateMachine.SetActionManager( vActionManager );  

  skapi.outputLine( "Initialization complete!" );

  // -------------------------------------------------------------------------------------------

  vStateMachine.Execute( "Rebuff1" );
//  vStateMachine.Execute( "NavigateDropToBeforeReservoir" );
  
  // -------------------------------------------------------------------------------------------

  this.mStateMachine.ChangeState( "Success" );

  // -------------------------------------------------------------------------------------------

  gLog.TraceLine( "State.Step05.Execute", "<< State.Step05.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_Step05_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
