//----------------------------------------------------------------------------------------------
//
// State - Step 06
//
//----------------------------------------------------------------------------------------------
//
// Enters reservoir and kills the 2 dark reverants
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-03-16   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_Step06()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_Step06_EnterState;
  this.ExitState = State_Step06_ExitState;
  this.Execute = State_Step06_Execute;
  this.OnActionFailed = State_Step06_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_Step06_EnterState()
{
  gLog.TraceLine( "State.Step06.EnterState", ">> State.Step06.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.Step06.EnterState", "<< State.Step06.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_Step06_ExitState()
{
  gLog.TraceLine( "State.Step06.ExitState", ">> State.Step06.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.Step06.ExitState", "<< State.Step06.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_Step06_Execute()
{
  gLog.TraceLine( "State.Step06.Execute", ">> State.Step06.Execute" );

  // -------------------------------------------------------------------------------------------

  var vStateModel;
  var vStateMachine;
  var vActionManager;

  // -------------------------------------------------------------------------------------------
  
  skapi.outputLine( "Initializing Step VI..." );
  
  vStateModel = new StateModel();
  vStateModel.ReadConfigFromFile( "NavigateOutside/Config/StateModel_06.xml" );

  vActionManager = new ActionManager();
  vActionManager.ReadConfigFromFile( "NavigateOutside/Config/Action_06.xml" );
  
  vStateMachine = new StateMachine();
  vStateMachine.SetStateModel( vStateModel );
  vStateMachine.SetActionManager( vActionManager );  

  skapi.outputLine( "Initialization complete!" );

  // -------------------------------------------------------------------------------------------

  vStateMachine.Execute( "NavigatePlatformBeforeReservoirToReservoir" );
  
  // -------------------------------------------------------------------------------------------

  this.mStateMachine.ChangeState( "Success" );

  // -------------------------------------------------------------------------------------------

  gLog.TraceLine( "State.Step06.Execute", "<< State.Step06.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_Step06_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
