//----------------------------------------------------------------------------------------------
//
// State - Step 07
//
//----------------------------------------------------------------------------------------------
//
// Runs to 2nd part of reservoir
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-03-16   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_Step07()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_Step07_EnterState;
  this.ExitState = State_Step07_ExitState;
  this.Execute = State_Step07_Execute;
  this.OnActionFailed = State_Step07_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_Step07_EnterState()
{
  gLog.TraceLine( "State.Step07.EnterState", ">> State.Step07.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.Step07.EnterState", "<< State.Step07.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_Step07_ExitState()
{
  gLog.TraceLine( "State.Step07.ExitState", ">> State.Step07.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.Step07.ExitState", "<< State.Step07.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_Step07_Execute()
{
  gLog.TraceLine( "State.Step07.Execute", ">> State.Step07.Execute" );

  // -------------------------------------------------------------------------------------------

  var vStateModel;
  var vStateMachine;
  var vActionManager;

  // -------------------------------------------------------------------------------------------
  
  skapi.outputLine( "Initializing Step VII..." );
  
  vStateModel = new StateModel();
  vStateModel.ReadConfigFromFile( "Reservoir/Config/StateModel_07.xml" );

  vActionManager = new ActionManager();
  vActionManager.ReadConfigFromFile( "Reservoir/Config/Action_07.xml" );
  
  vStateMachine = new StateMachine();
  vStateMachine.SetStateModel( vStateModel );
  vStateMachine.SetActionManager( vActionManager );  

  skapi.outputLine( "Initialization complete!" );

  // -------------------------------------------------------------------------------------------

  vStateMachine.Execute( "NavigateDropToJump" );
//  vStateMachine.Execute( "NavigateOlthoiToEnd" );
//  vStateMachine.Execute( "EnterPartTwo" );
  
  // -------------------------------------------------------------------------------------------

  this.mStateMachine.ChangeState( "Success" );

  // -------------------------------------------------------------------------------------------

  gLog.TraceLine( "State.Step07.Execute", "<< State.Step07.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_Step07_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
