//----------------------------------------------------------------------------------------------
//
// State - Step 08
//
//----------------------------------------------------------------------------------------------
//
// Runs 2nd part of reservoir hands sluice to golem and recalls
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-04-07   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_Step08()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_Step08_EnterState;
  this.ExitState = State_Step08_ExitState;
  this.Execute = State_Step08_Execute;
  this.OnActionFailed = State_Step08_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_Step08_EnterState()
{
  gLog.TraceLine( "State.Step08.EnterState", ">> State.Step08.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.Step08.EnterState", "<< State.Step08.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_Step08_ExitState()
{
  gLog.TraceLine( "State.Step08.ExitState", ">> State.Step08.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.Step08.ExitState", "<< State.Step08.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_Step08_Execute()
{
  gLog.TraceLine( "State.Step08.Execute", ">> State.Step08.Execute" );

  // -------------------------------------------------------------------------------------------

  var vStateModel;
  var vStateMachine;
  var vActionManager;

  // -------------------------------------------------------------------------------------------
  
  skapi.outputLine( "Initializing Step VIII..." );
  
  vStateModel = new StateModel();
  vStateModel.ReadConfigFromFile( "Reservoir/Config/StateModel_08.xml" );

  vActionManager = new ActionManager();
  vActionManager.ReadConfigFromFile( "Reservoir/Config/Action_08.xml" );
  
  vStateMachine = new StateMachine();
  vStateMachine.SetStateModel( vStateModel );
  vStateMachine.SetActionManager( vActionManager );  

  skapi.outputLine( "Initialization complete!" );

  // -------------------------------------------------------------------------------------------

  vStateMachine.Execute( "NavigateDropToJump" );
//  vStateMachine.Execute( "JumpPart3" );
//  vStateMachine.Execute( "NavigateJumpToGolem" );
//  vStateMachine.Execute( "GiveSluice" );
  
  // -------------------------------------------------------------------------------------------

  this.mStateMachine.ChangeState( "Success" );

  // -------------------------------------------------------------------------------------------

  gLog.TraceLine( "State.Step08.Execute", "<< State.Step08.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_Step08_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
