//----------------------------------------------------------------------------------------------
//
// State - Step 10
//
//----------------------------------------------------------------------------------------------
//
// Runs thru foundry, hands bellows to golem, recalls to drop
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-03-16   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_Step10()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_Step10_EnterState;
  this.ExitState = State_Step10_ExitState;
  this.Execute = State_Step10_Execute;
  this.OnActionFailed = State_Step10_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_Step10_EnterState()
{
  gLog.TraceLine( "State.Step10.EnterState", ">> State.Step10.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.Step10.EnterState", "<< State.Step10.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_Step10_ExitState()
{
  gLog.TraceLine( "State.Step10.ExitState", ">> State.Step10.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.Step10.ExitState", "<< State.Step10.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_Step10_Execute()
{
  gLog.TraceLine( "State.Step10.Execute", ">> State.Step10.Execute" );

  // -------------------------------------------------------------------------------------------

  var vStateModel;
  var vStateMachine;
  var vActionManager;

  // -------------------------------------------------------------------------------------------

  skapi.outputLine( "Initializing Step X..." );
  
  vStateModel = new StateModel();
  vStateModel.ReadConfigFromFile( "Foundry/Config/StateModel_10.xml" );

  vActionManager = new ActionManager();
  vActionManager.ReadConfigFromFile( "Foundry/Config/Action_10.xml" );
  
  vStateMachine = new StateMachine();
  vStateMachine.SetStateModel( vStateModel );
  vStateMachine.SetActionManager( vActionManager );  

  skapi.outputLine( "Initialization complete!" );

  // -------------------------------------------------------------------------------------------

  vStateMachine.Execute( "NavigateDropToStairs" );
//  vStateMachine.Execute( "KillSluiceRoom" );
//  vStateMachine.Execute( "UnlockDoor" );
//  vStateMachine.Execute( "NavigateJumpToGolem" );
//  vStateMachine.Execute( "GiveBellows" );

  // -------------------------------------------------------------------------------------------

  this.mStateMachine.ChangeState( "Success" );

  // -------------------------------------------------------------------------------------------

  gLog.TraceLine( "State.Step10.Execute", "<< State.Step10.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_Step10_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
