//----------------------------------------------------------------------------------------------
//
// State - Step 11
//
//----------------------------------------------------------------------------------------------
//
// runs to behemoth spawn spot
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-03-16   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_Step11()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_Step11_EnterState;
  this.ExitState = State_Step11_ExitState;
  this.Execute = State_Step11_Execute;
  this.OnActionFailed = State_Step11_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_Step11_EnterState()
{
  gLog.TraceLine( "State.Step11.EnterState", ">> State.Step11.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.Step11.EnterState", "<< State.Step11.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_Step11_ExitState()
{
  gLog.TraceLine( "State.Step11.ExitState", ">> State.Step11.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.Step11.ExitState", "<< State.Step11.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_Step11_Execute()
{
  gLog.TraceLine( "State.Step11.Execute", ">> State.Step11.Execute" );

  // -------------------------------------------------------------------------------------------

  var vStateModel;
  var vStateMachine;
  var vActionManager;

  // -------------------------------------------------------------------------------------------
  
  skapi.outputLine( "Initializing Step XI..." );
  
  vStateModel = new StateModel();
  vStateModel.ReadConfigFromFile( "NavigateOutside/Config/StateModel_11.xml" );

  vActionManager = new ActionManager();
  vActionManager.ReadConfigFromFile( "NavigateOutside/Config/Action_11.xml" );
  
  vStateMachine = new StateMachine();
  vStateMachine.SetStateModel( vStateModel );
  vStateMachine.SetActionManager( vActionManager );  

  skapi.outputLine( "Initialization complete!" );

  // -------------------------------------------------------------------------------------------

  vStateMachine.Execute( "NavigateDropToBehemoth" );
  
  // -------------------------------------------------------------------------------------------

  this.mStateMachine.ChangeState( "Success" );

  // -------------------------------------------------------------------------------------------

  gLog.TraceLine( "State.Step11.Execute", "<< State.Step11.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_Step11_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
