//----------------------------------------------------------------------------------------------
//
// State - Step 12
//
//----------------------------------------------------------------------------------------------
//
// kill behemoth and hellfire
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-03-16   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_Step12()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_Step12_EnterState;
  this.ExitState = State_Step12_ExitState;
  this.Execute = State_Step12_Execute;
  this.OnActionFailed = State_Step12_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_Step12_EnterState()
{
  gLog.TraceLine( "State.Step12.EnterState", ">> State.Step12.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.Step12.EnterState", "<< State.Step12.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_Step12_ExitState()
{
  gLog.TraceLine( "State.Step12.ExitState", ">> State.Step12.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.Step12.ExitState", "<< State.Step12.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_Step12_Execute()
{
  gLog.TraceLine( "State.Step12.Execute", ">> State.Step12.Execute" );

  // -------------------------------------------------------------------------------------------

  var vStateModel;
  var vStateMachine;
  var vActionManager;

  // -------------------------------------------------------------------------------------------
  
  skapi.outputLine( "Initializing Step XII..." );
  
  vStateModel = new StateModel();
  vStateModel.ReadConfigFromFile( "Tenkarrdun/Config/StateModel_12.xml" );

  vActionManager = new ActionManager();
  vActionManager.ReadConfigFromFile( "Tenkarrdun/Config/Action_12.xml" );
  
  vStateMachine = new StateMachine();
  vStateMachine.SetStateModel( vStateModel );
  vStateMachine.SetActionManager( vActionManager );  

  skapi.outputLine( "Initialization complete!" );

  // -------------------------------------------------------------------------------------------

  vStateMachine.Execute( "WaitBehemoth" );
//  vStateMachine.Execute( "NavigateBeforeBehemothToBehemoth" );
  
  // -------------------------------------------------------------------------------------------

  this.mStateMachine.ChangeState( "Success" );

  // -------------------------------------------------------------------------------------------

  gLog.TraceLine( "State.Step12.Execute", "<< State.Step12.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_Step12_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
