//----------------------------------------------------------------------------------------------
//
// State - Step 13
//
//----------------------------------------------------------------------------------------------
//
// runs from behemoth to before keep
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2013-13-16   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_Step13()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_Step13_EnterState;
  this.ExitState = State_Step13_ExitState;
  this.Execute = State_Step13_Execute;
  this.OnActionFailed = State_Step13_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_Step13_EnterState()
{
  gLog.TraceLine( "State.Step13.EnterState", ">> State.Step13.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.Step13.EnterState", "<< State.Step13.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_Step13_ExitState()
{
  gLog.TraceLine( "State.Step13.ExitState", ">> State.Step13.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.Step13.ExitState", "<< State.Step13.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_Step13_Execute()
{
  gLog.TraceLine( "State.Step13.Execute", ">> State.Step13.Execute" );

  // -------------------------------------------------------------------------------------------

  var vStateModel;
  var vStateMachine;
  var vActionManager;

  // -------------------------------------------------------------------------------------------
  
  skapi.outputLine( "Initializing Step XIII..." );
  
  vStateModel = new StateModel();
  vStateModel.ReadConfigFromFile( "NavigateOutside/Config/StateModel_13.xml" );

  vActionManager = new ActionManager();
  vActionManager.ReadConfigFromFile( "NavigateOutside/Config/Action_13.xml" );
  
  vStateMachine = new StateMachine();
  vStateMachine.SetStateModel( vStateModel );
  vStateMachine.SetActionManager( vActionManager );  

  skapi.outputLine( "Initialization complete!" );

  // -------------------------------------------------------------------------------------------

  vStateMachine.Execute( "NavigateAboveLavaFlowsToSafeBeforeKeep" );
  
  // -------------------------------------------------------------------------------------------

  this.mStateMachine.ChangeState( "Success" );

  // -------------------------------------------------------------------------------------------

  gLog.TraceLine( "State.Step13.Execute", "<< State.Step13.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_Step13_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
