//----------------------------------------------------------------------------------------------
//
// State - Step 14
//
//----------------------------------------------------------------------------------------------
//
// kills relics and enters portal
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2014-14-16   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_Step14()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_Step14_EnterState;
  this.ExitState = State_Step14_ExitState;
  this.Execute = State_Step14_Execute;
  this.OnActionFailed = State_Step14_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_Step14_EnterState()
{
  gLog.TraceLine( "State.Step14.EnterState", ">> State.Step14.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.Step14.EnterState", "<< State.Step14.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_Step14_ExitState()
{
  gLog.TraceLine( "State.Step14.ExitState", ">> State.Step14.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.Step14.ExitState", "<< State.Step14.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_Step14_Execute()
{
  gLog.TraceLine( "State.Step14.Execute", ">> State.Step14.Execute" );

  // -------------------------------------------------------------------------------------------

  var vStateModel;
  var vStateMachine;
  var vActionManager;

  // -------------------------------------------------------------------------------------------
  
  skapi.outputLine( "Initializing Step XIV..." );
  
  vStateModel = new StateModel();
  vStateModel.ReadConfigFromFile( "OutsideKeep/Config/StateModel_14.xml" );

  vActionManager = new ActionManager();
  vActionManager.ReadConfigFromFile( "OutsideKeep/Config/Action_14.xml" );
  
  vStateMachine = new StateMachine();
  vStateMachine.SetStateModel( vStateModel );
  vStateMachine.SetActionManager( vActionManager );  

  skapi.outputLine( "Initialization complete!" );

  // -------------------------------------------------------------------------------------------

  vStateMachine.Execute( "Rebuff1" );
//  vStateMachine.Execute( "NavigateSafeBeforeKeepToPortal" );
  
  // -------------------------------------------------------------------------------------------

  this.mStateMachine.ChangeState( "Success" );

  // -------------------------------------------------------------------------------------------

  gLog.TraceLine( "State.Step14.Execute", "<< State.Step14.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_Step14_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
