//----------------------------------------------------------------------------------------------
//
// State - Step 15
//
//----------------------------------------------------------------------------------------------
//
// 
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-04-13   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_Step15()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_Step15_EnterState;
  this.ExitState = State_Step15_ExitState;
  this.Execute = State_Step15_Execute;
  this.OnActionFailed = State_Step15_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_Step15_EnterState()
{
  gLog.TraceLine( "State.Step15.EnterState", ">> State.Step15.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.Step15.EnterState", "<< State.Step15.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_Step15_ExitState()
{
  gLog.TraceLine( "State.Step15.ExitState", ">> State.Step15.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.Step15.ExitState", "<< State.Step15.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_Step15_Execute()
{
  gLog.TraceLine( "State.Step15.Execute", ">> State.Step15.Execute" );

  // -------------------------------------------------------------------------------------------

  var vStateModel;
  var vStateMachine;
  var vActionManager;

  // -------------------------------------------------------------------------------------------
  
  skapi.outputLine( "Initializing Step XV..." );
  
  vStateModel = new StateModel();
  vStateModel.ReadConfigFromFile( "Keep/Config/StateModel_15.xml" );

  vActionManager = new ActionManager();
  vActionManager.ReadConfigFromFile( "Keep/Config/Action_15.xml" );
  
  vStateMachine = new StateMachine();
  vStateMachine.SetStateModel( vStateModel );
  vStateMachine.SetActionManager( vActionManager );  

  skapi.outputLine( "Initialization complete!" );

  // -------------------------------------------------------------------------------------------

  vStateMachine.Execute( "Rebuff1" );
//  vStateMachine.Execute( "NavigateLeg1" );
//  vStateMachine.Execute( "NavigateLeg9" );
//  vStateMachine.Execute( "Rebuff2" );
  
  // -------------------------------------------------------------------------------------------

  this.mStateMachine.ChangeState( "Success" );

  // -------------------------------------------------------------------------------------------

  gLog.TraceLine( "State.Step15.Execute", "<< State.Step15.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_Step15_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
