//----------------------------------------------------------------------------------------------
//
// State -  enter reservoir
//
//----------------------------------------------------------------------------------------------
//
// ...
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-27   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_EnterReservoir()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_EnterReservoir_EnterState;
  this.ExitState = State_EnterReservoir_ExitState;
  this.Execute = State_EnterReservoir_Execute;
  this.OnActionFailed = State_EnterReservoir_OnActionFailed;

}

//----------------------------------------------------------------------------------------------

function State_EnterReservoir_EnterState()
{
  gLog.TraceLine( "State.EnterReservoir.EnterState", ">> State.EnterReservoir.EnterState" );

  this.Inherited_EnterState();

  gLog.TraceLine( "Lib.State.EnterReservoir.EnterState", "<< State.EnterReservoir.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_EnterReservoir_ExitState()
{
  gLog.TraceLine( "State.EnterReservoir.ExitState", ">> State.EnterReservoir.ExitState" );

  this.Inherited_ExitState();

  gLog.TraceLine( "State.EnterReservoir.ExitState", "<< State.EnterReservoir.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_EnterReservoir_Execute()
{
  gLog.TraceLine( "State.EnterReservoir.Execute", ">> State.EnterReservoir.Execute" );

  skapi.WaitEvent( 2000, wemFullTimeout );

  gInteract.EnsureCombatMode( false );

  var vAcf = skapi.AcfNew();
  vAcf.szName = "* Portal"
  var vPortal = vAcf.AcoGet();
  if( vPortal != null )
  {
    vPortal.Use();
    skapi.WaitEvent( 60000, wemSpecific, evidOnEndPortalSelf );
  }

  this.mStateMachine.ChangeState( "Success" );

  gLog.TraceLine( "State.EnterReservoir.Execute", "<< State.EnterReservoir.Execute" );
}

//----------------------------------------------------------------------------------------------

function State_EnterReservoir_OnActionFailed( pSource, pAction, pReason )
{
  // Do stuff here
}

//----------------------------------------------------------------------------------------------
