//----------------------------------------------------------------------------------------------
//
// Action - Buff
//
//----------------------------------------------------------------------------------------------
//
// declares required functions in a action
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-05   Initial version.
//
// FIXME:
//  - BuffManager cannot handle 2 buffs at same time
//
//----------------------------------------------------------------------------------------------

function Action_Buff()
{
  // Member variables
  this.mBuffProfileName = "";

  // Member functions
  this.StartAction = Action_Buff_StartAction;
  this.PauseAction = Action_Buff_PauseAction;
  this.ResumeAction = Action_Buff_ResumeAction;
  this.AbortAction = Action_Buff_AbortAction;
  this.CheckWand = Action_Buff_CheckWand;
  this.SetBuffProfileName = Action_Buff_SetBuffProfileName;
  this.SetWandName = Action_Buff_SetWandName;
  this.SetWieldAction = Action_Buff_SetWieldAction;
}

//----------------------------------------------------------------------------------------------

function Action_Buff_StartAction()
{
  this.Inherited_StartAction();
  this.CheckWand();
  if( this.mIsPaused )
  {
    return;
  }
  gBuffManager.StartBuff( this.mBuffProfileName );
}

//----------------------------------------------------------------------------------------------

function Action_Buff_PauseAction()
{
  if( gBuffManager.mCurrentProfile != null )
  {
    gBuffManager.PauseBuff();
    gInteract.WaitActionComplete( 2000 );
  }
  this.Inherited_PauseAction();
}

//----------------------------------------------------------------------------------------------

function Action_Buff_ResumeAction()
{
  this.Inherited_ResumeAction();
  this.CheckWand();
  if( this.mIsPaused )
  {
    return;
  }
  if( gBuffManager.mCurrentProfile == null )
  {
    gBuffManager.StartBuff( this.mBuffProfileName );
  }
  else
  {
    gBuffManager.ResumeBuff();
  }
}

//----------------------------------------------------------------------------------------------

function Action_Buff_AbortAction()
{
  if( gBuffManager.mCurrentProfile != null )
  {
    gBuffManager.AbortBuff();
    gInteract.WaitActionComplete( 2000 );
  }
  this.Inherited_AbortAction();
}

//----------------------------------------------------------------------------------------------

function Action_Buff_CheckWand()
{
  if( skapi.AcoFromEqm( eqmWeapons ) == null )
  {
    gLog.DebugLine( "Lib.Action.Buff.CheckWand", "Adding wield action" );
    this.mActionManager.AddAction( this.mWieldAction );
    if( this.mIsPaused )
    {
      return;
    }
  }

  if( skapi.AcoFromEqm( eqmWeapons ).szName != this.mWandName )
  {
    gLog.DebugLine( "Lib.Action.Buff.CheckWand", "Adding wield action" );
    this.mActionManager.AddAction( this.mWieldAction );
  }
}

//----------------------------------------------------------------------------------------------

function Action_Buff_SetBuffProfileName( pBuffProfileName )
{
  this.mBuffProfileName = pBuffProfileName;
}

//----------------------------------------------------------------------------------------------

function Action_Buff_SetWandName( pWandName )
{
  this.mWandName = pWandName;
}

//----------------------------------------------------------------------------------------------

function Action_Buff_SetWieldAction( pWieldAction )
{
  this.mWieldAction = pWieldAction;
}

//----------------------------------------------------------------------------------------------
