//----------------------------------------------------------------------------------------------
//
// Action - Drink Potion
//
//----------------------------------------------------------------------------------------------
//
// Drinks potions until specified level
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-24   Initial version.
//
//----------------------------------------------------------------------------------------------

function Action_DrinkPotion()
{
  // Member fuctions
  this.StartAction = Action_DrinkPotion_StartAction;
  this.ResumeAction = Action_DrinkPotion_ResumeAction;

  this.SetVitalName = Action_DrinkPotion_VitalName;
  this.SetVitalPct = Action_DrinkPotion_SetVitalPct;
  this.SetPotionName = Action_DrinkPotion_SetPotionName;

  this.Drink = Action_DrinkPotion_Drink;
  this.DrinkOnce = Action_DrinkPotion_DrinkOnce;
}

//----------------------------------------------------------------------------------------------

function Action_DrinkPotion_StartAction()
{
  this.Inherited_StartAction();
  this.Drink();
}

//----------------------------------------------------------------------------------------------

function Action_DrinkPotion_ResumeAction()
{
  this.Inherited_ResumeAction();
  this.Drink();
}

//----------------------------------------------------------------------------------------------

function Action_DrinkPotion_Drink()
{
  gLog.TraceLine( "Lib.Action.DrinkPotion.Drink", ">> Action.DrinkPotion.Drink" );

  while( true )
  {
    eval( "var vCond = gPlayer.Current"+this.mVitalName+"() < gPlayer.Max"+this.mVitalName+"()*this.mVitalPct/100" );
    if( !vCond || this.mIsPaused || this.mIsAborted )
    {
      break;
    }
    this.DrinkOnce();
    skapi.WaitEvent( 100 );
  }

  gLog.TraceLine( "Lib.Action.DrinkPotion.Drink", "<< Action.DrinkPotion.Drink" );
}

//----------------------------------------------------------------------------------------------

function Action_DrinkPotion_DrinkOnce()
{
  gLog.TraceLine( "Lib.Action.DrinkPotion.DrinkOnce", ">> Action.DrinkPotion.DrinkOnce" );

  eval( "var vCond = gPlayer.Current"+this.mVitalName+"() < gPlayer.Max"+this.mVitalName+"()*this.mVitalPct/100" );

  if( vCond )
  {
    gInteract.EnsureCombatMode( false );

    if( this.mPotionName == null )
    {
      gLog.InfoLine( "Lib.Action.DrinkPotion.DrinkOnce", "PotionName not set" );
    }

    var vPotion = skapi.AcoFindInInv( this.mPotionName );

    if( vPotion == null )
    {
      gLog.InfoLine( "Lib.Action.DrinkPotion.DrinkOnce", "No Potion found in inventory" );
    }
   
    vPotion.Use();

    gInteract.WaitActionComplete( 2000 );
  }

  gLog.TraceLine( "Lib.Action.DrinkPotiont.DrinkOnce", "<< Action.DrinkPotion.DrinkOnce" );
}

//----------------------------------------------------------------------------------------------

function Action_DrinkPotion_VitalName( pVitalName )
{
  this.mVitalName = pVitalName;
}

//----------------------------------------------------------------------------------------------

function Action_DrinkPotion_SetVitalPct( pVitalPct )
{
  this.mVitalPct = pVitalPct;
}

//----------------------------------------------------------------------------------------------

function Action_DrinkPotion_SetPotionName( pPotionName )
{
  this.mPotionName = pPotionName;
}

//----------------------------------------------------------------------------------------------
