//----------------------------------------------------------------------------------------------
//
// Action - Fletch
//
//----------------------------------------------------------------------------------------------
//
// Fletches arrows/quarrels if needed
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-27   Initial version.
//
//----------------------------------------------------------------------------------------------

function Action_Fletch()
{
  // Member fuctions
  this.StartAction = Action_Fletch_StartAction;
  this.ResumeAction = Action_Fletch_ResumeAction;
  this.Fletch = Action_Fletch_Fletch;
  this.FletchOnce = Action_Fletch_FletchOnce;

  this.SetShaftName = Action_Fletch_SetShaftName;
  this.SetHeadName = Action_Fletch_SetHeadName;
  this.SetArrowName = Action_Fletch_SetArrowName;
  this.SetNofArrows = Action_Fletch_SetNofArrows;
}

//----------------------------------------------------------------------------------------------

function Action_Fletch_StartAction()
{
  this.Inherited_StartAction();
  this.Fletch();
}

//----------------------------------------------------------------------------------------------

function Action_Fletch_ResumeAction()
{
  this.Inherited_ResumeAction();
  this.Fletch();
}

//----------------------------------------------------------------------------------------------

function Action_Fletch_Fletch()
{
  gLog.TraceLine( "Lib.Action.Fletch.Fletch", ">> Action.Fletch.Fletch" );

  var vNofArrows;

  while( true )
  {
    vNofArrows = skapi.CitemOfKindInInv( this.mArrowName );

    var vEqmArrowAco = skapi.AcoFromEqm( eqmAmmo );
    if( vEqmArrowAco != null )
    {
      vNofArrows = vNofArrows+vEqmArrowAco.citemStack;
    }

    gLog.DebugLine( "Lib.Action.Fletch.Fletch", "Arrows found: "+vNofArrows );

    if( vNofArrows > this.mNofArrows )
    {
      break;
    }

    this.FletchOnce();
    skapi.WaitEvent( 100 );
  }

  gLog.TraceLine( "Lib.Action.Fletch.Fletch", "<< Action.Fletch.Fletch" );
}

//----------------------------------------------------------------------------------------------

function Action_Fletch_FletchOnce()
{
  gLog.TraceLine( "Lib.Action.Fletch.FletchOnce", ">> Action.Fletch.FletchOnce" );

  // FIXME:
  //  - Wrong, should be action
  gInteract.EnsureCombatMode( false );

  var vHead = skapi.AcoFindInInv( this.mHeadName );
  var vShaft = skapi.AcoFindInInv( this.mShaftName );

  vHead.UseOnAco( vShaft );
  gInteract.WaitActionComplete( 2000 );

  gLog.TraceLine( "Lib.Action.Fletch.FletchOnce", "<< Action.Fletch.FletchOnce" );
}

//----------------------------------------------------------------------------------------------

function Action_Fletch_SetShaftName( pShaftName )
{
  this.mShaftName = pShaftName;
}

//----------------------------------------------------------------------------------------------

function Action_Fletch_SetHeadName( pHeadName )
{
  this.mHeadName = pHeadName;
}

//----------------------------------------------------------------------------------------------

function Action_Fletch_SetArrowName( pArrowName )
{
  this.mArrowName = pArrowName;
}

//----------------------------------------------------------------------------------------------

function Action_Fletch_SetNofArrows( pNofArrows )
{
  this.mNofArrows = pNofArrows;
}

//----------------------------------------------------------------------------------------------
