//----------------------------------------------------------------------------------------------
//
// Action - Go To Map Loc
//
//----------------------------------------------------------------------------------------------
//
// Goes straight to a specific location
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-02-10   Initial version.
//
//----------------------------------------------------------------------------------------------

function Action_GotoMapLoc()
{
  // Member fuctions
  this.StartAction = Action_GotoMapLoc_StartAction;
  this.ResumeAction = Action_GotoMapLoc_ResumeAction;
  this.SetMapLoc = Action_GotoMapLoc_SetMapLoc;
  this.SetDistance = Action_GotoMapLoc_SetDistance;
  this.Go = Action_GotoMapLoc_Go;
  this.OnActionComplete = Action_GotoMapLoc_OnActionComplete;
}

//----------------------------------------------------------------------------------------------

function Action_GotoMapLoc_StartAction()
{
  this.Inherited_StartAction();
  this.Go();
}

//----------------------------------------------------------------------------------------------

function Action_GotoMapLoc_PauseAction()
{
  skapi.CancelNav();
  this.mRoute.StopRoute();
}

//----------------------------------------------------------------------------------------------

function Action_GotoMapLoc_ResumeAction()
{
  this.Inherited_ResumeAction();
  this.Go();
}

//----------------------------------------------------------------------------------------------

function Action_GotoMapLoc_AbortAction()
{
  skapi.CancelNav();
  this.Inherited_AbortAction();
}

//----------------------------------------------------------------------------------------------

function Action_GotoMapLoc_Go()
{
  gLog.TraceLine( "Lib.Action.GotoMapLoc.Go", ">> Action.GotoMapLoc.Go()" );

  skapi.AddHandler( evidOnActionComplete, this );

  this.mWaiting = true;
  skapi.GoToMapLoc( this.mMapLoc, this.mDistance, false, true, 5000 );

  skapi.RemoveHandler( evidOnActionComplete, this );

  gLog.TraceLine( "Lib.Action.GotoMapLoc.Go", "<< Action.GotoMapLoc.Go" );
}

//----------------------------------------------------------------------------------------------

function Action_GotoMapLoc_WaitUntilArrived()
{
  while( true )
  {
    if( !this.mWaiting )
    {
      break;
    }

    if( this.mIsPaused || this.mIsAborted )
    {
      break;
    }

  }
}

//----------------------------------------------------------------------------------------------

function Action_GotoMapLoc_OnActionComplete()
{
  this.mWaiting = false;
}

//----------------------------------------------------------------------------------------------

function Action_GotoMapLoc_SetMapLoc( pMapLoc )
{
  this.mMapLoc = pMapLoc;
}

//----------------------------------------------------------------------------------------------

function Action_GotoMapLoc_SetDistance( pDistance )
{
  this.mDistance = pDistance;
}
