//----------------------------------------------------------------------------------------------
//
// Action - Pause
//
//----------------------------------------------------------------------------------------------
//
// The pause action, does nothing and just wait for the command "resume"
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-05   Initial version.
//
//----------------------------------------------------------------------------------------------

function Action_Pause()
{
  // Member variables
  this.mIsWaiting = false;

  // Member functions
  this.StartAction = Action_Pause_StartAction;
  this.ResumeAction = Action_Pause_ResumeAction;
  this.WaitForResume = Action_Pause_WaitForResume;
  this.OnCommand = Action_Pause_OnCommand

  // Event functions
  skapi.AddHandler( evidOnCommand, this );
}

//----------------------------------------------------------------------------------------------

function Action_Pause_StartAction()
{
  this.Inherited_StartAction();
  this.WaitForResume();
}

//----------------------------------------------------------------------------------------------

function Action_Pause_ResumeAction()
{
  this.Inherited_ResumeAction();
  this.WaitForResume();
}

//----------------------------------------------------------------------------------------------

function Action_Pause_OnCommand( szCmd )
{
  if( szCmd == "resume" )
  {
    this.mIsWaiting = false;
  }
}

//----------------------------------------------------------------------------------------------

function Action_Pause_WaitForResume()
{
  this.mIsWaiting = true;
  while( this.mIsWaiting && !this.mIsPaused )
  {
    skapi.WaitEvent( 100 );
  }
}

//----------------------------------------------------------------------------------------------
