//----------------------------------------------------------------------------------------------
//
// Action - Salvage
//
//----------------------------------------------------------------------------------------------
//
// The Salvage action, uses salvage manager to find out what needs to be salvaged
// Currently not interruptable since I am paranoid about salvaging my equipment, only
// call it when it is reasonably safe.
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-02-16   Initial version.
//
//----------------------------------------------------------------------------------------------

function Action_Salvage()
{
  // Member variables
  this.mProtectedItems = new Array();

  // Member functions
  this.StartAction = Action_Salvage_StartAction;
  
  this.DragToSalvage = Action_Salvage_DragToSalvage;
  this.SetProtectedItems = Action_Salvage_SetProtectedItems;
}

//----------------------------------------------------------------------------------------------

function Action_Salvage_StartAction()
{
  var vSalvage;
  var vItem;
  var vMaterial;
  var vFilter;
  var vBags;

  this.Inherited_StartAction();
  
  // Activate ust
  skapi.AcoFindInInv( "Ust" ).Use();
  
  vSalvage = gSalvageManager.Items();
  
  if( vSalvage.Count == 0 )
  {
    return;
  }
  
  while( true )
  {
    vItem = vSalvage.Item( 0 );

    vMaterial = vItem.szName.split( " " );
    vMaterial = vMaterial[ 0 ];
    
    if( !this.DragToSalvage( vItem ) )
    {
      return;
    }

    vFilter = skapi.AcfNew();
    vFilter.szName = "Salvaged "+vMaterial+" (*)";
    vFilter.olc = olcInventory;
    
    vBags = vFilter.CoacoGet();
    
    var e = new Enumerator( vBags );
    for( ; !e.atEnd(); e.moveNext() )
    {
      vItem = e.item();
      if( vItem.szName != "Salvaged "+vMaterial+" (100)" )
      {
        if( !this.DragToSalvage( vItem ) )
        {
          return;
        }
        else
        {
          break;
        }
      }
    }
  
    vItem = vSalvage.Item( 0 );
    vSalvage.RemoveAco( vItem );
    gSalvageManager.RemoveItem( vItem );
    
    // push the button
    skapi.MouseMove( -400, -150 );
    skapi.MouseButton( ibuttonLeft );

    skapi.WaitEvent( 200, wemFullTimeout );

    if( vSalvage.Count == 0 )
    {
      break;
    }
  }
}

//----------------------------------------------------------------------------------------------

function Action_Salvage_DragToSalvage( pAco )
{
  var i;
  
  for( i = 0; i < this.mProtectedItems.length; i++ )
  {
    if( pAco.szName == this.mProtectedItems[ i ] )
    {
      skapi.outputLine( "=====> WARNING: Salvage - Protected item selected!" );
      return false;
    }
  }

  gPlayer.OpenMainPack();

  if( pAco.acoContainer.coacoContents.Item( 0 ) != pAco )
  {
    pAco.MoveToPack( 0 );
    // FIXME: way too long? should handle as event
    skapi.WaitEvent( 1000, wemFullTimeout );
  }
  
  skapi.MouseMove( -270, -180 );
  skapi.MouseButton( ibuttonLeft, kmoDown );
  skapi.WaitEvent( 100 );
  
  if( skapi.acoSelected != pAco )
  {
    skapi.MouseButton( ibuttonLeft, kmoUp );
    skapi.outputLine( "=====> WARNING: Salvage - Wrong item selected!" );
    return false;
  }
  
  skapi.MouseMove( -500, -150 );
  skapi.MouseButton( ibuttonLeft, kmoUp );
  skapi.WaitEvent( 100 );
  
  return true;
}

//----------------------------------------------------------------------------------------------

function Action_Salvage_SetProtectedItems( pProtectedItems )
{
  this.mProtectedItems = pProtectedItems.split( "," );
}

//----------------------------------------------------------------------------------------------
