//----------------------------------------------------------------------------------------------
//
// Action - Use Heal Kit
//
//----------------------------------------------------------------------------------------------
//
// Heals up to a specifc percentage
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2001-09-12   Initial version.
//
//----------------------------------------------------------------------------------------------

function Action_UseHealKit()
{
  // Member fuctions
  this.StartAction = Action_UseHealKit_StartAction;
  this.ResumeAction = Action_UseHealKit_ResumeAction;
  this.SetHealKitName = Action_UseHealKit_SetHealKitName;
  this.SetHealthPct = Action_UseHealKit_SetHealthPct;
  this.Heal = Action_UseHealKit_Heal;

  this.HealOnce = Action_UseHealKit_HealOnce;
}

//----------------------------------------------------------------------------------------------

function Action_UseHealKit_StartAction()
{
  this.Inherited_StartAction();
  this.Heal();
}

//----------------------------------------------------------------------------------------------

function Action_UseHealKit_ResumeAction()
{
  this.Inherited_ResumeAction();
  this.Heal();
}

//----------------------------------------------------------------------------------------------

function Action_UseHealKit_Heal()
{
  gLog.TraceLine( "Lib.Action.UseHealKit.Heal", ">> Action.UseHealKit.Heal" );

  while( gPlayer.CurrentHealth() < gPlayer.MaxHealth()*this.mHealthPct )
  {
    if( this.mIsPaused || this.mIsAborted )
    {
      break;
    }
    this.HealOnce();
    skapi.WaitEvent( 100 );
  }

  gLog.TraceLine( "Lib.Action.UseHealKit.Heal", "<< Action.UseHealKit.Heal" );
}

//----------------------------------------------------------------------------------------------

function Action_UseHealKit_HealOnce()
{
  gLog.TraceLine( "Lib.Action.UseHealKit.HealOnce", ">> Action.UseHealKit.HealOnce" );

  if( gPlayer.CurrentHealth() < gPlayer.MaxHealth()*this.mHealthPct )
  {
    // FIXME:
    //  - Wrong should be action
    gInteract.EnsureCombatMode( false );

    if( this.mHealKitName == null )
    {
      gLog.InfoLine( "Lib.Action.UseHealKit.HealOnce", "HealKitName not set" );
    }

    var vKit = skapi.AcoFindInInv( this.mHealKitName );

    if( vKit == null )
    {
      gLog.InfoLine( "Lib.Action.UseHealKit.HealOnce", "No Heal Kit found in inventory" );
    }
   
    vKit.UseOnAco( gPlayer.Aco() );

    gInteract.WaitActionComplete( 2000 );
  }

  gLog.TraceLine( "Lib.Action.UseHealKit.HealOnce", "<< Action.UseHealKit.HealOnce" );
}

//----------------------------------------------------------------------------------------------

function Action_UseHealKit_SetHealKitName( pName )
{
  this.mHealKitName = pName;
}

//----------------------------------------------------------------------------------------------

function Action_UseHealKit_SetHealthPct( pHealthPct )
{
  this.mHealthPct = pHealthPct/100;
}

//----------------------------------------------------------------------------------------------
