//----------------------------------------------------------------------------------------------
//
// Config Object
//
//----------------------------------------------------------------------------------------------
//
// Reads cofiguration Xml files and stores settings
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-08-31   Initial version.
//
//----------------------------------------------------------------------------------------------
//
// FIXME:
//  - Need to be able to handle other types than string
//  - Parameters need to be able to handle complex structures
//
//----------------------------------------------------------------------------------------------

function Config()
{
  gLog.TraceLine( "Lib.Config.New", ">> Config.New" );

  // Member variables
  this.mXmlDoc = new ActiveXObject( "MSXML2.DOMDocument.4.0" );
  this.mXmlDoc.async = false;

  // Member methods
  this.ReadFromFile = Config_ReadFromFile;
  this.GetValueString = Config_GetValueString;
  this.Enumerator = Config_Enumerator;

  gLog.TraceLine( "Lib.Config.New", "<< Config.New" );
}

//----------------------------------------------------------------------------------------------

function Config_ReadFromFile( pFileName )
{
  gLog.TraceLine( "Lib.Config.ReadFromFile", ">> Config.ReadFromFile( "+pFileName+" )" );

  var vErr;
  var vXmlDoc;

  vXmlDoc = new ActiveXObject( "MSXML2.DOMDocument.4.0" );
  vXmlDoc.async = false;
  vXmlDoc.load( pFileName );
  vErr = this.mXmlDoc.parseError;

  if( vErr.errorCode != 0 )
  {
    gLog.ErrorLine( "Lib.Config.ReadFromFile", "The Xml file "+pFileName+" failed to parse." );
    gLog.ErrorLine( "Lib.Config.ReadFromFile", "Reason: "+vErr.reason );
    skapi.outputLine( vErr.Reason );
  }
  else
  {
    this.mXmlDoc = vXmlDoc;
  }
  gLog.TraceLine( "Lib.Config.ReadFromFile", "<< Config.ReadFromFile" );
}

//----------------------------------------------------------------------------------------------

function Config_GetValueString( pConfigName )
{
  gLog.TraceLine( "Lib.Config.GetValueString", ">> Config.GetValueString( "+pConfigName+" )" );

  var vNode;

  vNode = this.mXmlDoc.selectSingleNode( pConfigName );

  gLog.TraceLine( "Lib.Config.GetValueString", "<< Config.GetValueString: "+vNode.text );
  return vNode.text;
}

//----------------------------------------------------------------------------------------------

function Config_Enumerator( pConfigName )
{
  gLog.TraceLine( "Lib.Config.Enumerator", ">> Config.Enumerator( "+pConfigName+ " )" );

  var vNodeList;
  var vEnum;

  vNodeList = this.mXmlDoc.selectNodes( pConfigName );
  vEnum = new ConfigEnumerator( pConfigName, vNodeList );

  gLog.TraceLine( "Lib.Config.Enumerator", "<< Config.Enumerator: #"+vEnum.mNodeList.length );
  return vEnum;
}

//----------------------------------------------------------------------------------------------
