//----------------------------------------------------------------------------------------------
//
// Config Enumeration Object
//
//----------------------------------------------------------------------------------------------
//
// Enumeration to loop over lists of configurations
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-08-31   Initial version.
//
//----------------------------------------------------------------------------------------------
//
// FIXME:
//  - Need to be able to handle other types than string
//  - Parameters need to be able to handle complex structures
//
//----------------------------------------------------------------------------------------------

function ConfigEnumerator( pXmlPath, pNodeList )
{
  gLog.TraceLine( "Lib.ConfigEnumerator.New", ">> ConfigEnumerator.New( "+pXmlPath+", #"+pNodeList.length+" )" );

  // Member variables
  this.mNodeList = pNodeList;
  this.mEnumerator = new Enumerator( this.mNodeList );
  this.mXmlPath = pXmlPath;

  // Member functions
  this.atEnd = ConfigEnumerator_atEnd;
  this.moveNext = ConfigEnumerator_moveNext;
  this.GetValueString = ConfigEnumerator_GetValueString;
  this.Enumerator = ConfigEnumerator_Enumerator;

  gLog.TraceLine( "Lib.ConfigEnumerator.New", "<< ConfigEnumerator.New" );
}

//----------------------------------------------------------------------------------------------

function ConfigEnumerator_atEnd()
{
  gLog.TraceLine( "Lib.ConfigEnumerator.atEnd", ">> ConfigEnumerator.atEnd" );
  var vResult = this.mEnumerator.atEnd();
  gLog.TraceLine( "Lib.ConfigEnumerator.atEnd", "<< ConfigEnumerator.atEnd: "+vResult );
  return vResult;
}

//----------------------------------------------------------------------------------------------

function ConfigEnumerator_moveNext()
{
  gLog.TraceLine( "Lib.ConfigEnumerator.moveNext", ">> ConfigEnumerator.moveNext" );
  gLog.TraceLine( "Lib.ConfigEnumerator.moveNext", "<< ConfigEnumerator.moveNext" );
  return this.mEnumerator.moveNext();
}

//----------------------------------------------------------------------------------------------

function ConfigEnumerator_GetValueString( pConfigName )
{
  gLog.TraceLine( "Lib.ConfigEnumerator.GetValueString", ">> ConfigEnumerator.GetValueString( "+this.mXmlPath+"/"+pConfigName+" )" );

  var vNode;

  if( pConfigName != "" )
  {
    vNode = this.mEnumerator.item().selectSingleNode( pConfigName );
  }
  else
  {
    vNode = this.mEnumerator.item();
  }

  gLog.TraceLine( "Lib.ConfigEnumerator.GetValueString", "<< ConfigEnumerator.GetValueString: "+vNode.text );
  return vNode.text;
}

//----------------------------------------------------------------------------------------------

function ConfigEnumerator_Enumerator( pConfigName )
{
  gLog.TraceLine( "Lib.ConfigEnumerator.Enumerator", ">> ConfigEnumerator.Enumerator( "+this.mXmlPath+"/"+pConfigName+" )" );

  var vNodeList, vEnum;

  vNodeList = this.mEnumerator.item().selectNodes( pConfigName );
  vEnum = new ConfigEnumerator( this.mXmlPath+"/"+pConfigName, vNodeList );

  gLog.TraceLine( "Lib.ConfigEnumerator.Enumerator", "<< ConfigEnumerator.Enumerator: #"+vEnum.mNodeList.length );

  return vEnum;
}


//----------------------------------------------------------------------------------------------
