//----------------------------------------------------------------------------------------------
//
// Dynamic object
//
//----------------------------------------------------------------------------------------------
//
// Has some generic functions that do "eval" stuff
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-04   Initial version.
// 2.1   2002-09-10   Added simple inheritance.
//
//----------------------------------------------------------------------------------------------
//
// FIXME:
//  - Implements should inherit member variables too, how?
//  - Only handles one overrride, Inherited_X gets overwritten if done twice.
//
//----------------------------------------------------------------------------------------------

function Dynamic()
{
  // Member functions
  this.SetParameter = Dynamic_SetParameter;
  this.ClassName = Dynamic_ClassName;
  this.Implements = Dynamic_Implements;
}

//----------------------------------------------------------------------------------------------

function Dynamic_SetParameter( pObject, pParamName, pParamValue )
{
  gLog.TraceLine( "Lib.Dynamic.SetParameter", ">> Dynamic.SetParameter( "+pParamName+", "+pParamValue+" )" );

  if( pObject.hasOwnProperty( "Set"+pParamName ) )
  {
    gLog.DebugLine( "Lib.Dynamic.SetParameter", "Setting parameter '"+pParamName+"' to value '"+pParamValue+"' on object "+this.ClassName( pObject ) );
    eval( "pObject.Set"+pParamName+"( '"+pParamValue+"' )" );
  }
  else
  {
    gLog.WarnLine( "Lib.Dynamic.SetParameter", "Failed to set parameter '"+pParamName+"' to value '"+pParamValue+"', on object "+this.ClassName( pObject ) );
  }

  gLog.TraceLine( "Lib.Dynamic.SetParameter", "<< Dynamic.SetParameter" );
}

//----------------------------------------------------------------------------------------------

function Dynamic_ClassName( pObject )
{
  gLog.TraceLine( "Lib.Dynamic.ClassName", ">> Dynamic.ClassName" );

  var vClassName = ""+pObject.constructor;

  vClassName = vClassName.substr( 9, vClassName.indexOf( "(" )-9 );

  gLog.TraceLine( "Lib.Dynamic.ClassName", "<< Dynamic.ClassName: "+vClassName );

  return vClassName;
}

//----------------------------------------------------------------------------------------------

function Dynamic_Implements( pObject, pTemplate )
{
  gLog.TraceLine( "Lib.Dynamic.Implements", ">> Dynamic.Implements( "+this.ClassName( pObject )+", "+this.ClassName( pTemplate )+" )" );

  var e = new Enumerator( pTemplate.mRequiredMembers );

  gLog.DebugLine( "Lib.Dynamic.Implements", "Nof Required Members: "+pTemplate.mRequiredMembers.length );

  for( ; !e.atEnd(); e.moveNext() )
  {
    var vMember = e.item();

    gLog.DebugLine( "Lib.Dynamic.Implements", "Checking Member: "+vMember );

    if( pObject.hasOwnProperty( vMember ) )
    {
      gLog.DebugLine( "Lib.Dynamic.Implements", this.ClassName( pObject )+" already has member "+vMember+" adding member Inherited_"+vMember+ " instead" );
      eval( "pObject.Inherited_"+vMember+" = pTemplate."+vMember );
    }
    else
    {
      gLog.DebugLine( "Lib.Dynamic.Implements", this.ClassName( pObject )+" does not have member "+vMember+" adding template defintion" );
      eval( "pObject."+vMember+" = pTemplate."+vMember );
    }
  }

  gLog.TraceLine( "Lib.Dynamic.Implements", "<< Dynamic.Implements" );

}

//----------------------------------------------------------------------------------------------

