//----------------------------------------------------------------------------------------------
//
// ExperienceTracker Object
//
//----------------------------------------------------------------------------------------------
//
// Objects tracks total experience changes.
//
//----------------------------------------------------------------------------------------------
//
// 1.0   2001-07-25   Initial version.  Basic structure stolen from Ogfist, but uses my event
//                    dispatcher model.
// 1.1   2001-08-03   Name change.
// 2.0   2002-09-22   Updated to new framework.
//
//----------------------------------------------------------------------------------------------
//
// FIXME:
//  - Quick hack, needs to be rewritten
//
//----------------------------------------------------------------------------------------------

function ExperienceTracker()
{
  // Member Variables
  this.TotalExp = 0;
  this.TotalTime = 0;
  this.StartExp = 0;
  this.CurrentExp = 0;
  this.LastExp = 0;
  this.IsRunning = false;
  this.mTimer = skapi.TimerNew();

  // Event handlers
  this.OnStatUnspentExp = ExperienceTracker_OnStatUnspentExp;
  skapi.AddHandler( evidOnStatUnspentExp, this );

  // Methods
  this.GainedExp = ExperienceTracker_GainedExp;
  this.Start = ExperienceTracker_Start;
  this.Stop = ExperienceTracker_Stop;
  this.Reset = ExperienceTracker_Reset;
}

//----------------------------------------------------------------------------------------------

function ExperienceTracker_OnStatUnspentExp( exp )
{
  if( this.IsRunning )
  {
    if( exp < this.LastExp )
    {
      this.TotalExp = this.TotalExp+( this.LastExp-exp );
    }
    if( this.StartExp == 0 )
    {
      this.StartExp = exp;
      this.CurrentExp = exp;
    }
    else
    {
      this.CurrentExp = exp;
    }
    this.LastExp = exp;
    gLog.InfoLine( "Statistics.Experience.Total", "BEGIN" );
    gLog.InfoLine( "Statistics.Experience.Total", "Elapsed time: "+( ( this.TotalTime+this.mTimer.cmsec )/( 1000*60*60 ) ) );
    gLog.InfoLine( "Statistics.Experience.Total", "Total exp gained: "+this.GainedExp() );
    gLog.InfoLine( "Statistics.Experience.Total", "Average per hour: "+this.GainedExp()/( ( this.TotalTime+this.mTimer.cmsec )/( 1000*60*60 ) ) );
    gLog.InfoLine( "Statistics.Experience.Total", "END" );
  }
}

//----------------------------------------------------------------------------------------------

function ExperienceTracker_GainedExp()
{
  if( this.IsRunning )
  {
    return this.TotalExp+( this.CurrentExp-this.StartExp );
  }
  else
  {
    return this.TotalExp;
  }
}

//----------------------------------------------------------------------------------------------

function ExperienceTracker_Start()
{
  this.IsRunning = true;
  this.mTimer = skapi.TimerNew();
}

//----------------------------------------------------------------------------------------------


function ExperienceTracker_Stop()
{
  this.IsRunning = false;
  this.TotalExp = this.TotalExp+( this.CurrentExp-this.StartExp );
  this.StartExp = 0;
  this.CurrentExp = 0;
  this.LastExp = 0;
  this.TotalTime = this.TotalTime+this.TotalTime+this.mTimer.cmsec;
}

//----------------------------------------------------------------------------------------------

function ExperienceTracker_Reset()
{
  this.IsRunning = false;
  this.TotalExp = 0;
  this.StartExp = 0;
  this.CurrentExp = 0;
  this.mTimer = skapi.TimerNew();
}

//----------------------------------------------------------------------------------------------
