//----------------------------------------------------------------------------------------------
//
// Interact Object
//
//----------------------------------------------------------------------------------------------
//
// Class to handle interactions with AC client, mouse moves, keyboard etc.
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-01   Initial version.
//
//----------------------------------------------------------------------------------------------
//
// FIXME:
//  - Too much in this class now, some should be moved to player class
//
//----------------------------------------------------------------------------------------------

function Interact()
{
  // Member variables
  this.mAnimationWait = false;

  // Member functions
  this.Keys = Interact_Keys;
  this.KeyDown = Interact_KeyDown;
  this.KeyUp = Interact_KeyUp;
  this.PasteLine = Interact_PasteLine;
  this.WaitForChat = Interact_WaitForChat;
  this.EnsureCombatMode = Interact_EnsureCombatMode;
  this.WaitActionComplete = Interact_WaitActionComplete;
  this.OnActionComplete = Interact_OnActionComplete;
}

//----------------------------------------------------------------------------------------------

function Interact_Keys( pString )
{
  this.WaitForChat();
  skapi.Keys( pString );
}

//----------------------------------------------------------------------------------------------

function Interact_KeyDown( pKey )
{
  skapi.Keys( pKey, kmoDown );
}

//----------------------------------------------------------------------------------------------

function Interact_KeyUp( pKey )
{
  skapi.Keys( pKey, kmoUp );
}

//----------------------------------------------------------------------------------------------

function Interact_PasteLine( pString )
{
  this.WaitForChat();
  skapi.Keys( "\r" );
  skapi.PasteSz( pString );
  skapi.Keys( "\r" );
}

//----------------------------------------------------------------------------------------------

function Interact_WaitForChat()
{
  while( skapi.fInChatBuffer )
  {
    skapi.WaitEvent( 100 );
  }
}

//----------------------------------------------------------------------------------------------

function Interact_EnsureCombatMode( pCombatMode )
{
  gLog.TraceLine( "Lib.Interact.EnsureCombatMode", ">> Interact.EnsureCombatMode( "+pCombatMode+" )" );

  // FIXME: 
  //   - 5 retries, might be too much if higher priority actions gets added on queue
  //   - Hammer cmidToggleCombat if skapi.arc = busy?

  var vResult = false;

  if( skapi.fCombatMode != pCombatMode )
  {
    for( var i = 0; skapi.fCombatMode == pCombatMode || i < 5; i++ )
    {
      gLog.DebugLine( "Lib.Interact.EnsureCombatMode", "Before toggle: "+skapi.fCombatMode );
      this.Keys( cmidToggleCombat );

      for( var i2 = 0; i2 < 20; i2++ )
      {
        skapi.WaitEvent( 100, wemFullTimeout );
        gLog.DebugLine( "Lib.Interact.EnsureCombatMode", "CombatMode: "+skapi.fCombatMode );
        if( pCombatMode == skapi.fCombatMode )
        {
          // FIXME
          //  - This is pretty dumb, since animations are not the same length
          skapi.WaitEvent( 300, wemFullTimeout );
          break;
        }
      }

      gLog.DebugLine( "Lib.Interact.EnsureCombatMode", "After toggle: "+skapi.fCombatMode );
      if( pCombatMode == skapi.fCombatMode )
      {
        vResult = true;
        break;
      }
      gLog.DebugLine( "Lib.Interact.EnsureCombatMode", "Mode switch failed, trying again" );
    }
  }
  else
  {
    vResult = true;
  }

  gLog.TraceLine( "Lib.Interact.EnsureCombatMode", "<< Interact.EnsureCombatMode: "+vResult );
  return vResult;
}

//----------------------------------------------------------------------------------------------

function Interact_WaitActionComplete( pTimeout )
{
  gLog.TraceLine( "Lib.Interact.WaitActionComplete", ">> Interact.WaitActionComplete" );

  // FIXME:
  //   - I actually want to check the "you are too busy" message, but have found no way of doing that.

  var vTimer = skapi.TimerNew();

  skapi.AddHandler( evidOnActionComplete, this );
  this.mAnimationWait = true;

  while( this.mAnimationWait )
  {
    if( vTimer.cmsec > pTimeout )
    {
      this.mAnimationWait = false;
      gLog.DebugLine( "Lib.Interact.WaitActionComplete", "Timeout!" );
    }
    skapi.WaitEvent( 100 );
  }  
  skapi.RemoveHandler( evidOnActionComplete, this );

  gLog.TraceLine( "Lib.Interact.WaitActionComplete", "<< Interact.WaitActionComplete" );
}

//----------------------------------------------------------------------------------------------

function Interact_OnActionComplete()
{
  gLog.TraceLine( "Lib.Interact.OnActionComplete", ">> EVENT: Interact.OnActionComplete" );
  this.mAnimationWait = false;
  gLog.TraceLine( "Lib.Interact.OnActionComplete", "<< EVENT: Interact.OnActionComplete" );
}

//----------------------------------------------------------------------------------------------
