//----------------------------------------------------------------------------------------------
//
// Periodic Filter
//
//----------------------------------------------------------------------------------------------
//
// Filters out logging to only write periodically
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-01-05   Initial version.
//
//----------------------------------------------------------------------------------------------

function PeriodicFilter()
{
  this.mCategories = new Dictionary();
  this.mInBlock = true;
  this.mLogBlock = true;

  this.ApplyFilter = PeriodicFilter_ApplyFilter;
  this.SetInterval = PeriodicFilter_SetInterval;
  this.LogCategory = PeriodicFilter_LogCategroy;
}

//----------------------------------------------------------------------------------------------

function PeriodicFilter_ApplyFilter( pCategory, pLevel, pString )
{
  if( pString == "BEGIN" )
  {
    this.mInBlock = true;
    if( this.LogCategory( pCategory ) )
    {
      this.mLogBlock = true;
    }
    return "";
  }

  if( pString == "END" )
  {
    this.mInBlock = false;
    this.mLogBlock = false;
    return "";
  }

  if( !this.mInBlock )
  {
    if( !this.LogCategory( pCategory ) )
    {
      pString = "";
    }
  }
  else
  {
  	if( !this.mLogBlock )
  	{
  	  pString = "";
  	}
  }

  return pString;
}

//----------------------------------------------------------------------------------------------

function PeriodicFilter_SetInterval( pInterval )
{
  this.mInterval = pInterval;
}

//----------------------------------------------------------------------------------------------

function PeriodicFilter_LogCategroy( pCategory )
{
  if( !this.mCategories.Exists( pCategory ) )
  {
    this.mCategories.Item( pCategory ) = skapi.TimerNew();
    return true;
  }
  else 
  {
//    skapi.outputLine( "Timer: "+this.mCategories.Item( pCategory ).cmsec+", "+this.mInterval );
    if( this.mCategories.Item( pCategory ).cmsec > this.mInterval*1000 )
    {
      this.mCategories.Item( pCategory ).cmsec = 0;
      return true;
    }
  }
  return false;
}

//----------------------------------------------------------------------------------------------
