//----------------------------------------------------------------------------------------------
//
// Standard File Writer Object
//
//----------------------------------------------------------------------------------------------
//
// Writes log output to a file
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-01-05   Initial version.
//
//----------------------------------------------------------------------------------------------

function StdFileWriter()
{
  gLog.TraceLine( "Lib.StdFileWriter.New", "Enter StdFileWriter.New" );

  // Member variables
  this.mFilename = "undefined.txt";
  this.mDelete = false;
  this.mFirst = true;
  this.mFso = new ActiveXObject( "Scripting.FileSystemObject" );

  // Member functions
  this.SetFileName = StdFileWriter_SetFileName;
  this.SetDelete = StdFileWriter_SetDelete;
  this.WriteLine = StdFileWriter_WriteLine;

  gLog.TraceLine( "Lib.StdFileWriter.New", "Exit StdFileWriter.New" );
}

//----------------------------------------------------------------------------------------------

function StdFileWriter_SetFileName( pFileName )
{
  gLog.TraceLine( "Lib.StdFileWriter.SetFileName", "Enter StdFileWriter.SetFileName" );

  this.mFileName = pFileName;

  gLog.TraceLine( "Lib.StdFileWriter.SetFileName", "Exit StdFileWriter.SetFileName" );
}

//----------------------------------------------------------------------------------------------

function StdFileWriter_SetDelete( pDelete )
{
  gLog.TraceLine( "Lib.StdFileWriter.SetDelete", "Enter StdFileWriter.SetDelete" );

  if( pDelete == "true" || pDelete == "TRUE" || pDelete == "True" )
  {
    this.mDelete = true;
  }
  else
  {
    this.mDelete = false;
  }

  this.mFirst = true;

  gLog.TraceLine( "Lib.StdFileWriter.SetDelete", "Exit StdFileWriter.SetDelete" );
}

//----------------------------------------------------------------------------------------------

function StdFileWriter_WriteLine( pString )
{
  if( this.mFirst )
  {
    this.mFirst = false;
    try
    {
      if( this.mDelete )
      {
        this.mFso.DeleteFile( this.mFileName );
      }
    }
    catch( e )
    {
    }
  }

  var vFile = this.mFso.OpenTextFile( this.mFileName, 8, true);
  vFile.WriteLine( pString );
  vFile.Close();
}

//----------------------------------------------------------------------------------------------

