//----------------------------------------------------------------------------------------------
//
// Player Object
//
//----------------------------------------------------------------------------------------------
//
// Info about current player, not much yet.
//
//----------------------------------------------------------------------------------------------
//
// 1.0   2001-07-25   Initial version.
// 2.0   2002-09-01   Updated to new framework.
//
//----------------------------------------------------------------------------------------------

function Player()
{
  gLog.TraceLine( "Lib.Player.New", ">> Lib.Player.New" );

  // Add methods to object
  this.Name = Player_Name;  
  this.CurrentHealth = Player_CurrentHealth;
  this.CurrentStamina = Player_CurrentStamina;
  this.CurrentMana = Player_CurrentMana;
  this.MaxHealth = Player_MaxHealth;
  this.MaxStamina = Player_MaxStamina;
  this.MaxMana = Player_MaxMana;
  this.Aco = Player_Aco;
  this.MapLoc = Player_MapLoc;
  this.OpenMainPack = Player_OpenMainPack;

  gLog.TraceLine( "Lib.Player.New", "<< Lib.Player.New" );
}

//----------------------------------------------------------------------------------------------

function Player_Name()
{
  gLog.TraceLine( "Lib.Player.Name", ">> Lib.Player.Name" );
  var vName = skapi.szName;
  gLog.TraceLine( "Lib.Player.Name", "<< Lib.Player.Name:"+vName );
  return vName;
}

//----------------------------------------------------------------------------------------------

function Player_CurrentHealth()
{
  gLog.TraceLine( "Lib.Player.CurrentHealth", ">> Lib.Player.CurrentHealth" );
  var vHealth = skapi.healthCur;
  gLog.TraceLine( "Lib.Player.CurrentHealth", "<< Lib.Player.CurrentHealth: "+vHealth );
  return vHealth;
}

//----------------------------------------------------------------------------------------------

function Player_CurrentStamina()
{
  gLog.TraceLine( "Lib.Player.CurrentStamina", ">> Lib.Player.CurrentStamina" );
  var vStamina = skapi.staminaCur;
  gLog.TraceLine( "Lib.Player.CurrentStamina", "<< Lib.Player.CurrentStamina: "+vStamina );
  return vStamina;
}

//----------------------------------------------------------------------------------------------

function Player_CurrentMana()
{
  gLog.TraceLine( "Lib.Player.CurrentMana", ">> Lib.Player.CurrentMana" );
  var vMana = skapi.manaCur;
  gLog.TraceLine( "Lib.Player.CurrentMana", "<< Lib.Player.CurrentMana: "+vMana );
  return vMana;
}

//----------------------------------------------------------------------------------------------

function Player_MaxHealth()
{
  gLog.TraceLine( "Lib.Player.MaxHealth", ">> Lib.Player.MaxHealth" );
  var vHealth = skapi.skInfoFromVital( vitalHealthMax ).lvlCur;
  gLog.TraceLine( "Lib.Player.MaxHealth", "<< Lib.Player.MaxHealth: "+vHealth );
  return vHealth;
}

//----------------------------------------------------------------------------------------------

function Player_MaxStamina()
{
  gLog.TraceLine( "Lib.Player.MaxStamina", ">> Lib.Player.MaxStamina" );
  var vStamina = skapi.skInfoFromVital( vitalStaminaMax ).lvlCur;
  gLog.TraceLine( "Lib.Player.MaxStamina", "<< Lib.Player.MaxStamina: "+vStamina );
  return vStamina;
}

//----------------------------------------------------------------------------------------------

function Player_MaxMana()
{
  gLog.TraceLine( "Lib.Player.MaxMana", ">> Lib.Player.MaxMana" );
  var vMana = skapi.skInfoFromVital( vitalManaMax ).lvlCur;
  gLog.TraceLine( "Lib.Player.MaxMana", "<< Lib.Player.MaxMana: "+vMana );
  return vMana;
}

//----------------------------------------------------------------------------------------------

function Player_Aco()
{
  gLog.TraceLine( "Lib.Player.Aco", ">> Lib.Player.Aco()" );

  var vAco = skapi.acoChar;

  gLog.TraceLine( "Lib.Player.Aco", "<< Lib.Player.Aco: #"+( vAco == null ? 0 : vAco.oid ) );
  return vAco;
}

//----------------------------------------------------------------------------------------------

function Player_MapLoc()
{
  return skapi.maplocCur;
}

//----------------------------------------------------------------------------------------------

function Player_OpenMainPack()
{
  gLog.TraceLine( "Lib.Player.OpenMainPack", ">> Lib.Player.OpenMainPack()" );

  skapi.acoChar.Use();

  gLog.TraceLine( "Lib.Player.OpenMainPack", "<< Lib.Player.OpenMainPack" );
}

//----------------------------------------------------------------------------------------------
