//----------------------------------------------------------------------------------------------
//
// State - Corpse Looter
//
//----------------------------------------------------------------------------------------------
//
// Finds targets
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2003-02-09   Initial version.
//
//----------------------------------------------------------------------------------------------
//
// FIXME:
//  - Still some hardcoded stuff in here
//
//----------------------------------------------------------------------------------------------

function State_CorpseLooter()
{
  // Member variables
  this.mSubStates = new Array();
  this.mCorpses = skapi.CoacoNew();

  // Member functions
  this.EnterState = State_CorpseLooter_EnterState;
  this.ExitState = State_CorpseLooter_ExitState;
  this.CheckCorpse = State_CorpseLooter_CheckCorpse;
  this.SetMaxDistance = State_CorpseLooter_SetMaxDistance;
  this.SetActionName = State_CorpseLooter_SetActionName;
  this.SetCorpseNames = State_CorpseLooter_SetCorpseNames;

  // Event handlers
  this.OnTimer = State_CorpseLooter_OnTimer;
  this.OnObjectCreate = State_CorpseLooter_OnObjectCreate;
  this.OnObjectDestroy = State_CorpseLooter_OnObjectDestroy;
}

//----------------------------------------------------------------------------------------------

function State_CorpseLooter_EnterState()
{
  gLog.TraceLine( "Lib.State.CorpseLooter.EnterState", ">> State.CorpseLooter.EnterState" );

  this.Inherited_EnterState();
  skapi.AddHandler( evidOnObjectCreate, this );
  skapi.AddHandler( evidOnObjectDestroy, this );
  gTimer.AddTimeout( "LootTimer", 300, this, true );

  gLog.TraceLine( "Lib.State.CorpseLooter.EnterState", "<< State.CorpseLooter.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_CorpseLooter_ExitState()
{
  gLog.TraceLine( "Lib.State.CorpseLooter.ExitState", ">> State.CorpseLooter.ExitState" );

  skapi.RemoveHandler( evidOnObjectCreate, this );
  skapi.RemoveHandler( evidOnObjectDestroy, this );
  gTimer.RemoveTimeout( "LootTimer" );
  this.Inherited_ExitState();

  gLog.TraceLine( "Lib.State.CorpseLooter.ExitState", "<< State.CorpseLooter.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_CorpseLooter_OnTimer( pData )
{
  if( this.mActionManager.HasActiveAction( this.mActionName ) )
  {
    return;
  }

  if( this.mActionManager.IdleTime() < 500 )
  {
    return;
  }
  
  if( this.mCorpses.Count == 0 )
  {
    return;
  }
  
  this.CheckCorpse();
}
  
//----------------------------------------------------------------------------------------------

function State_CorpseLooter_OnObjectCreate( pAco )
{
  for( i = 0; i < this.mCorpseNames.length; i++ )
  {
    if( pAco.szName == this.mCorpseNames[ i ] )
    {
      if( pAco.fExists )
      {
        if( gPlayer.MapLoc().Dist2DToMaploc( pAco.maploc ) < this.mMaxDistance )
        {
          this.mCorpses.AddAco( pAco );
        }
      }
    }
  }
}

//----------------------------------------------------------------------------------------------

function State_CorpseLooter_OnObjectDestroy( pAco )
{
  this.mCorpses.RemoveAco( pAco );
//  skapi.outputLine( "dest: "+AcoToString( pAco ) );
}

//----------------------------------------------------------------------------------------------

function State_CorpseLooter_CheckCorpse()
{
  gLog.TraceLine( "Lib.State.CorpseLooter.CheckCorpse", ">> State.CorpseLooter.CheckCorpse()" );

  var vAco = this.mCorpses.item( 0 );

  this.mCorpses.RemoveAco( vAco );

  this.mActionManager.GetAction( this.mActionName ).SetCorpse( vAco );
  this.mActionManager.AddAction( this.mActionName );

  gLog.TraceLine( "Lib.State.CorpseLooter.CheckCorpse", "<< State.CorpseLooter.CheckCorpse" );
}

//----------------------------------------------------------------------------------------------

function State_CorpseLooter_SetMaxDistance( pMaxDistance )
{
  this.mMaxDistance = pMaxDistance;
}

//----------------------------------------------------------------------------------------------

function State_CorpseLooter_SetActionName( pActionName )
{
  this.mActionName = pActionName;
}

//----------------------------------------------------------------------------------------------

function State_CorpseLooter_SetCorpseNames( pCorpseNames )
{
  this.mCorpseNames = pCorpseNames.split( "," );
}

//----------------------------------------------------------------------------------------------

