//----------------------------------------------------------------------------------------------
//
// State - Death Self
//
//----------------------------------------------------------------------------------------------
//
// Checks if player has died, and sets switches to new state
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-08-31   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_DeathSelf()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_DeathSelf_EnterState;
  this.ExitState = State_DeathSelf_ExitState;

  this.SetStateTransition = State_DeathSelf_SetStateTransition;

  // Event handlers
  this.OnDeathSelf = State_DeathSelf_OnDeathSelf;
}

//----------------------------------------------------------------------------------------------

function State_DeathSelf_EnterState()
{
  gLog.TraceLine( "Lib.State.DeathSelf.EnterState", ">> State.DeathSelf.EnterState" );

  this.Inherited_EnterState();

  skapi.AddHandler( evidOnDeathSelf, this );
  this.mWait = true;

  gLog.TraceLine( "Lib.State.DeathSelf.EnterState", "<< State.DeathSelf.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_DeathSelf_ExitState()
{
  gLog.TraceLine( "Lib.State.DeathSelf.ExitState", ">> State.DeathSelf.ExitState" );

  this.Inherited_ExitState();

  skapi.RemoveHandler( evidOnDeathSelf, this );

  gLog.TraceLine( "Lib.State.DeathSelf.ExitState", "<< State.DeathSelf.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_DeathSelf_SetStateTransition( pStateTransition )
{
  this.mStateTransition = pStateTransition;
}

//----------------------------------------------------------------------------------------------

function State_DeathSelf_OnDeathSelf( aco, sz )
{
  this.mStateMachine.ChangeState( this.mStateTransition );
}

//----------------------------------------------------------------------------------------------
