//----------------------------------------------------------------------------------------------
//
// State - Debug
//
//----------------------------------------------------------------------------------------------
//
// Listens to command and writes debug info to console
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-20   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_Debug()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_Debug_EnterState;
  this.ExitState = State_Debug_ExitState;

  // Event handlers
  this.OnCommand = State_Debug_OnCommand;
}

//----------------------------------------------------------------------------------------------

function State_Debug_EnterState()
{
  gLog.TraceLine( "Lib.State.Debug.EnterState", ">> State.Debug.EnterState" );

  this.Inherited_EnterState();
  skapi.AddHandler( evidOnCommand, this );

  gLog.TraceLine( "Lib.State.Debug.EnterState", "<< State.Debug.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_Debug_ExitState()
{
  gLog.TraceLine( "Lib.State.Debug.ExitState", ">> State.Debug.ExitState" );

  this.Inherited_ExitState();
  skapi.RemoveHandler( evidOnCommand, this );

  gLog.TraceLine( "Lib.State.Debug.ExitState", "<< State.Debug.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_Debug_OnCommand( sz )
{
  if( sz.substr( 0, 6 ) == "debug " )
  {
    // I have trouble sometimes with being in chat mode at wrong moments, this will fix it?
    skapi.Sleep( 500 );

    var vDebugCmd = sz.substr( 6 );

    if( vDebugCmd == "Distance" )
    {
      skapi.OutputLine( "Distance to target: "+skapi.maplocCur.Dist2DToMaploc( skapi.acoSelected.maploc ) );
    }
    if( vDebugCmd == "CombatMode" )
    {
      skapi.OutputLine( "CombatMode:"+skapi.fCombatMode )
    }
    if( vDebugCmd == "ocm" )
    {
      skapi.outputLine( "Target ocm: "+skapi.acoSelected.ocm );
    }
    if( vDebugCmd == "olc" )
    {
      skapi.outputLine( "Target olc: "+skapi.acoSelected.olc );
    }
  

  }
}

//----------------------------------------------------------------------------------------------
