//----------------------------------------------------------------------------------------------
//
// State - Target Finder
//
//----------------------------------------------------------------------------------------------
//
// Finds targets
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-20   Initial version.
//
//----------------------------------------------------------------------------------------------
//
// FIXME:
//  - Still some hardcoded stuff in here
//
//----------------------------------------------------------------------------------------------

function State_TargetFinder()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_TargetFinder_EnterState;
  this.ExitState = State_TargetFinder_ExitState;
  this.SetTarget = State_TargetFinder_SetTarget;
  this.SetTargetNames = State_TargetFinder_SetTargetNames;
  this.SetMaxDistance = State_TargetFinder_SetMaxDistance;
  this.SetActionName = State_TargetFinder_SetActionName;

  // Event handlers
  this.OnTimer = State_TargetFinder_OnTimer;
}

//----------------------------------------------------------------------------------------------

function State_TargetFinder_EnterState()
{
  gLog.TraceLine( "Lib.State.TargetFinder.EnterState", ">> State.TargetFinder.EnterState" );

  this.Inherited_EnterState();
  gTimer.AddTimeout( "TargetTimer", 200, this, true );

  gLog.TraceLine( "Lib.State.TargetFinder.EnterState", "<< State.TargetFinder.EnterState" );
}

//----------------------------------------------------------------------------------------------

function State_TargetFinder_ExitState()
{
  gLog.TraceLine( "Lib.State.TargetFinder.ExitState", ">> State.TargetFinder.ExitState" );

  gTimer.RemoveTimeout( "TargetTimer" );
  this.Inherited_ExitState();

  gLog.TraceLine( "Lib.State.TargetFinder.ExitState", "<< State.TargetFinder.ExitState" );
}

//----------------------------------------------------------------------------------------------

function State_TargetFinder_OnTimer( pData )
{
  if( this.mActionManager.HasActiveAction( this.mActionName ) )
  {
    return;
  }

  this.SetTarget();
}

//----------------------------------------------------------------------------------------------

function State_TargetFinder_SetTarget()
{
  var vAllTargets = skapi.coacoNew();
  var vFilter = skapi.AcfNew();
  var vTarget;

  vFilter.ocm = ocmMonster;
  vFilter.distMax = this.mMaxDistance;

  for( i = 0; i < this.mTargetNames.length; i++ )
  {
    vFilter.szName = this.mTargetNames[ i ];
    var vTargets = vFilter.CoacoGet();
    vTargets.Sort( skapi.sortByDist );
    var e = new Enumerator( vTargets );

    for( ; !e.atEnd(); e.moveNext() )
    {
      vAllTargets.AddAco( e.item() );
    }
  }

  vTarget = gTargetManager.SetTarget( vAllTargets );
  if( vTarget != null )
  {
    this.mActionManager.GetAction( this.mActionName ).SetTarget( vTarget );
    this.mActionManager.AddAction( this.mActionName );
  }
}

//----------------------------------------------------------------------------------------------

function State_TargetFinder_SetTargetNames( pTargetNames )
{
  this.mTargetNames = pTargetNames.split( "," );
}

//----------------------------------------------------------------------------------------------

function State_TargetFinder_SetMaxDistance( pMaxDistance )
{
  this.mMaxDistance = pMaxDistance;
}

//----------------------------------------------------------------------------------------------

function State_TargetFinder_SetActionName( pActionName )
{
  this.mActionName = pActionName;
}

//----------------------------------------------------------------------------------------------
