//----------------------------------------------------------------------------------------------
//
// State - Vital Manager
//
//----------------------------------------------------------------------------------------------
//
// Monitors one vital and takes actions when it gets too low
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-08-31   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_VitalManager()
{
  // Member variables
  this.mSubStates = new Array();

  // Member functions
  this.EnterState = State_VitalManager_EnterState;
  this.ExitState = State_VitalManager_ExitState;
  this.SetVitalName = Action_VitalManager_SetVitalName;
  this.SetVitalPct = Action_VitalManager_SetVitalPct;
  this.SetReactionType = Action_VitalManager_SetReactionType;
  this.SetActionName = Action_VitalManager_SetActionName;
  this.SetStateTransition = Action_VitalManager_SetStateTransition;
  

  // Event handlers
  this.OnVitals = State_VitalManager_OnVitals;
}

//----------------------------------------------------------------------------------------------

function State_VitalManager_EnterState()
{
  skapi.AddHandler( evidOnVitals, this );
}

//----------------------------------------------------------------------------------------------

function State_VitalManager_ExitState()
{
  skapi.RemoveHandler( evidOnVitals, this );
}

//----------------------------------------------------------------------------------------------

function Action_VitalManager_SetVitalName( pVitalName )
{
  this.mVitalName = pVitalName;
}

//----------------------------------------------------------------------------------------------

function Action_VitalManager_SetVitalPct( pVitalPct )
{
  this.mVitalPct = pVitalPct;
}

//----------------------------------------------------------------------------------------------

function Action_VitalManager_SetReactionType( pReactionType )
{
  this.mReactionType = pReactionType;
}

//----------------------------------------------------------------------------------------------

function Action_VitalManager_SetActionName( pActionName )
{
  this.mActionName = pActionName;
}

//----------------------------------------------------------------------------------------------

function Action_VitalManager_SetStateTransition( pStateTransition )
{
  this.mStateTransition = pStateTransition;
}

//----------------------------------------------------------------------------------------------

function State_VitalManager_OnVitals( pHealth, pStamina, pMana )
{
  if( !this.mActionManager.HasActiveAction( this.mActionName ) )
  {
    eval( "var vCond = gPlayer.Current"+this.mVitalName+"() < gPlayer.Max"+this.mVitalName+"()*this.mVitalPct/100" );
    if( vCond )
    {
      if( this.mReactionType == "Action" )
      {
        this.mActionManager.AddAction( this.mActionName );
      }
      else
      {
        this.mStateMachine.ChangeState( this.mStateTransition );
      }
    }
  }
}

//----------------------------------------------------------------------------------------------
