//----------------------------------------------------------------------------------------------
//
// Target Manager Object
//
//----------------------------------------------------------------------------------------------
//
// Handles target priority
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-22   Initial version.
//
//----------------------------------------------------------------------------------------------

function TargetManager()
{
  // Member variables
  this.mTargets = new Dictionary();

  // Member functions
  this.SetTarget = TargetManager_SetTarget;
  this.LowerPriority = TargetManager_LowerPriority;

  this.OnMeleeLastAttacker = TargetManager_OnMeleeLastAttacker;

  skapi.AddHandler( evidOnMeleeLastAttacker, this );
}

//----------------------------------------------------------------------------------------------

function TargetManager_SetTarget( pPossibleTargets )
{
  var e = new Enumerator( pPossibleTargets );
  var vTarget;
  var vPri;

  for( ; !e.atEnd(); e.moveNext() )
  {
    var vTemp = e.item();
    if( !this.mTargets.Exists( vTemp.oid ) )
    {
      vTarget = vTemp;
      break;
    }
    else
    {
      var vTempPri = this.mTargets( vTemp.oid );
      if( ( vTarget == null || vPri > vTempPri ) && vTempPri < 2 )
      {
        vPri = this.mTargets( vTemp.oid );
        vTarget = vTemp;
      }
    }
  }

  return vTarget;
//  if( vTarget != null )
//  {
//    skapi.SelectAco( vTarget );
//    return true;
//  }
//  return false;
}

//----------------------------------------------------------------------------------------------

function TargetManager_LowerPriority( pTarget )
{
  gLog.TraceLine( "Lib.TargetManager.LowerPriority", ">> TargetManager.LowerPriority()" );

  if( this.mTargets.Exists( pTarget.oid ) )
  {
    var vPri = this.mTargets( pTarget.oid );
    this.mTargets.remove( pTarget.oid );
    vPri++;
    this.mTargets.add( pTarget.oid, vPri );
    gLog.DebugLine( "Lib.TargetManager.LowerPriority", "Aco: "+AcoToString( pTarget )+", New Priority: "+vPri );
  }
  else
  {
    this.mTargets.add( pTarget.oid, 1 );
    gLog.DebugLine( "Lib.TargetManager.LowerPriority", "Aco: "+AcoToString( pTarget )+", New Priority: "+vPri );
  }
  gLog.TraceLine( "Lib.TargetManager.LowerPriority", "<< TargetManager.LowerPriority" );
}

//----------------------------------------------------------------------------------------------

function TargetManager_OnMeleeLastAttacker( aco )
{
  if( this.mTargets.Exists( aco.oid ) )
  {
    gLog.DebugLine( "Lib.TargetManager.OnMeleeLastAttacker", "OnMeleeLastAttacker: "+AcoToString( aco ) );
    this.mTargets.remove( aco.oid );
  }
}

//----------------------------------------------------------------------------------------------
