//----------------------------------------------------------------------------------------------
//
// Action - template
//
//----------------------------------------------------------------------------------------------
//
// Declares required functions in an action.
//
// I haven't found a way to tell which functions exists in a class, so i am forced to hardcode
// an array with function names.
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-05   Initial version.
//
//----------------------------------------------------------------------------------------------

function Action_Template()
{
  // Member functions
  this.SetActionManager = Action_SetActionManager;
  this.SetName = Action_SetName;
  this.SetPriority = Action_SetPriority;
  this.GetName = Action_GetName;
  this.GetPriority = Action_GetPriority;
  this.IsPaused = Action_IsPaused;
  this.IsAborted = Action_IsAborted;

  this.StartAction = Action_StartAction;
  this.PauseAction = Action_PauseAction;
  this.ResumeAction = Action_ResumeAction;
  this.AbortAction = Action_AbortAction;

  // Required member functions
  this.mRequiredMembers = new Array( "SetActionManager", "StartAction", "PauseAction",
                                     "ResumeAction", "AbortAction", "SetName", "SetPriority",
                                     "GetName", "GetPriority", "IsPaused", "IsAborted" );
}

//----------------------------------------------------------------------------------------------

function Action_SetActionManager( pActionManager )
{
  this.mActionManager = pActionManager;
}

//----------------------------------------------------------------------------------------------

function Action_SetName( pName )
{
  this.mName = pName;
}

//----------------------------------------------------------------------------------------------

function Action_SetPriority( pPriority )
{
  this.mPriority = pPriority;
}

//----------------------------------------------------------------------------------------------

function Action_GetName()
{
  return this.mName;
}

//----------------------------------------------------------------------------------------------

function Action_IsPaused()
{
  return this.mIsPaused;
}

//----------------------------------------------------------------------------------------------

function Action_IsAborted()
{
  return this.mIsAborted;
}

//----------------------------------------------------------------------------------------------

function Action_GetPriority()
{
  return this.mPriority;
}

//----------------------------------------------------------------------------------------------

function Action_StartAction()
{
  this.mIsPaused = false;
  this.mIsAborted = false;
}

//----------------------------------------------------------------------------------------------

function Action_PauseAction()
{
  this.mIsPaused = true;
}

//----------------------------------------------------------------------------------------------

function Action_ResumeAction()
{
  this.mIsPaused = false;
}

//----------------------------------------------------------------------------------------------

function Action_AbortAction()
{
  this.mIsPaused = false;
  this.mIsAborted = true;
}

//----------------------------------------------------------------------------------------------
