//----------------------------------------------------------------------------------------------
//
// State - Template
//
//----------------------------------------------------------------------------------------------
//
// Declares required functions in a state
//
// I haven't found a way to tell which functions exists in a class, so i am forced to hardcode
// an array with function names also.
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-05   Initial version.
//
//----------------------------------------------------------------------------------------------

function State_Template()
{
  // FIXME: 
  //  - How do i inherit member variables?
  this.mSubStates = new Array();

  // Member functions
  this.SetActionManager = State_SetActionManager;
  this.SetStateMachine = State_SetStateMachine;
  this.EnterState = State_EnterState;
  this.ExitState = State_ExitState;
  this.Exeute = State_Execute;
  this.AddSubState = State_AddSubState;
  this.RemoveSubState = State_RemoveSubState;
  this.DoActionSequence = State_DoActionSequence;
  this.DoAction = State_DoAction;
  this.OnActionFailed = State_OnActionFailed;
  this.GetName = State_GetName;
  this.SetName = State_SetName;

  // Required member functions
  this.mRequiredMembers = new Array( "SetActionManager", "SetStateMachine", 
                                     "EnterState", "ExitState", "Execute",
                                     "AddSubState", "RemoveSubState", "Initialize",
                                     "DoActionSequence", "DoAction", "OnActionFailed",
                                     "GetName", "SetName" );
}

//----------------------------------------------------------------------------------------------

function State_Initialize()
{
  this.mSubStates = new Array();
}

//----------------------------------------------------------------------------------------------

function State_SetActionManager( pActionManager )
{
  var e = new Enumerator( this.mSubStates );

  for( ; !e.atEnd(); e.moveNext() )
  {
    e.item().SetActionManager( pActionManager );
  }
  this.mActionManager = pActionManager;
}

//----------------------------------------------------------------------------------------------

function State_SetStateMachine( pStateMachine )
{
  var e = new Enumerator( this.mSubStates );

  for( ; !e.atEnd(); e.moveNext() )
  {
    e.item().SetStateMachine( pStateMachine );
  }
  this.mStateMachine = pStateMachine;
}

//----------------------------------------------------------------------------------------------

function State_EnterState()
{
  var e = new Enumerator( this.mSubStates );

  for( ; !e.atEnd(); e.moveNext() )
  {
    e.item().EnterState();
  }
}

//----------------------------------------------------------------------------------------------

function State_ExitState()
{
  var e = new Enumerator( this.mSubStates );

  for( ; !e.atEnd(); e.moveNext() )
  {
    e.item().ExitState();
  }
}

//----------------------------------------------------------------------------------------------

function State_Execute()
{
}

//----------------------------------------------------------------------------------------------

function State_AddSubState( pSubState )
{
  this.mSubStates.push( pSubState );
}

//----------------------------------------------------------------------------------------------

function State_RemoveSubState()
{
  throw "RemoveSubState: Not implemented yet!";
}

//----------------------------------------------------------------------------------------------

function State_DoActionSequence( pActions )
{
  for( var i = 0; i < pActions.length; i++ )
  {
    var vAction = pActions[ i ];
    this.mActionManager.AddAction( vAction );
    while( this.mActionManager.HasActiveAction( vAction ) )
    {
      this.mActionManager.ExecuteAction();
      skapi.WaitEvent( 100 );
    }
    if( this.mStateMachine.ShouldExitState() )
    {
      break;
    }
  }
}

//----------------------------------------------------------------------------------------------

function State_DoAction( pAction )
{
  this.mActionManager.AddAction( pAction );
  while( this.mActionManager.HasActiveAction( pAction ) )
  {
    this.mActionManager.ExecuteAction();
    skapi.WaitEvent( 100 );
  }
}

//----------------------------------------------------------------------------------------------

function State_OnActionFailed( pSource, pAction, pReason )
{
}

//----------------------------------------------------------------------------------------------

function State_GetName()
{
  return this.mName;
}

//----------------------------------------------------------------------------------------------

function State_SetName( pName )
{
  this.mName = pName;
}

//----------------------------------------------------------------------------------------------
