//----------------------------------------------------------------------------------------------
//
// Timer Object
//
//----------------------------------------------------------------------------------------------
//
// 
//
//----------------------------------------------------------------------------------------------
//
// 2.0   2002-09-06   Initial version.
//
//----------------------------------------------------------------------------------------------
//
// FIXME:
//  - Wierd timer effects sometimes, no idea why
//  - AddTimeout should return an ID not take it as a parameter, right now i couldn't use two
//    TragetFinder substates.
//
//----------------------------------------------------------------------------------------------

function Timer()
{
  gLog.TraceLine( "Lib.Timer.New", ">> Timer.New" );

  // Member variables
  this.mTimers = new Dictionary();

  // Member functions
  this.OnTimer = Timer_OnTimer;
  this.AddTimeout = Timer_AddTimeout;
  this.RemoveTimeout = Timer_RemoveTimeout;

  // Event handlers
  skapi.AddHandler( evidOnTimer, this );

  gLog.TraceLine( "Lib.Timer.New", ">> Timer.New" );
}

//----------------------------------------------------------------------------------------------

function Timer_AddTimeout( pName, pTimeout, pObject, pRepeat )
{
  gLog.TraceLine( "Lib.Timer.AddTimeout", ">> Timer.AddTimeout( "+pName+" )" );

  var vTimer = skapi.TimerNew();
  var vTimerData = new Dictionary();

  vTimerData.add( "Name", pName );
  vTimerData.add( "Timeout", pTimeout );
  vTimerData.add( "Object", pObject );
  vTimerData.add( "Repeat", pRepeat );
  vTimerData.add( "Timer", vTimer );

  gLog.DebugLine( "Lib.Timer.AddTimeout", "Nof active timers before add: "+this.mTimers.Count );
  this.mTimers.add( pName, vTimerData );
  gLog.DebugLine( "Lib.Timer.AddTimeout", "Nof active timers after add: "+this.mTimers.Count );

  vTimer.tag = pName;
  vTimer.cmsec = -pTimeout;

  gLog.TraceLine( "Lib.Timer.AddTimeout", "<< Timer.AddTimeout" );
}

//----------------------------------------------------------------------------------------------

function Timer_RemoveTimeout( pName )
{
  gLog.TraceLine( "Lib.Timer.RemoveTimeout", ">> Timer.RemoveTimeout( "+pName+" )" );

  var vTimerData = this.mTimers( pName );
  var vTimer = vTimerData( "Timer" );

  vTimer.cmsec = 0;
  
  gLog.DebugLine( "Lib.Timer.AddTimeout", "Nof active timers before remove: "+this.mTimers.Count );
  this.mTimers.remove( pName );
  gLog.DebugLine( "Lib.Timer.AddTimeout", "Nof active timers after remove: "+this.mTimers.Count );

  gLog.TraceLine( "Lib.Timer.RemoveTimeout", "<< Timer.RemoveTimeout" );
}

//----------------------------------------------------------------------------------------------

function Timer_OnTimer( pTimer )
{
  gLog.TraceLine( "Lib.Timer.OnTimer", ">> EVENT: Timer.OnTimer( "+pTimer.tag+" )" );

  gLog.DebugLine( "Lib.Timer.AddTimeout", "Nof active timers: "+this.mTimers.Count );
  var vTimerData = this.mTimers( pTimer.tag );

  gLog.DebugLine( "Lib.Timer.OnTimer", "TimerData: "+( vTimerData != null ) );
  gLog.DebugLine( "Lib.Timer.AddTimeout", "Nof active timers: "+this.mTimers.Count );

  if( vTimerData != null )
  {
    var vObject = vTimerData( "Object" );

    vObject.OnTimer( pTimer.tag );

    var vRepeat = vTimerData( "Repeat" );
    if( vRepeat )
    {
      vTimerData.remove( "Timer" );
      var vTimer = skapi.TimerNew();
      vTimerData.add( "Timer", vTimer );

      vTimer.tag = vTimerData( "Name" );
      vTimer.cmsec = -vTimerData( "Timeout" );
    }
  }
  else
  {
    this.mTimers.remove( pTimer.tag );
  }

  gLog.TraceLine( "Lib.Timer.OnTimer", "<< EVENT: Timer.OnTimer" );
}

//----------------------------------------------------------------------------------------------
